{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}


module Curry_REPL (C_GoalCompile (..), d_C_writeErrorMsg, d_C_main, d_C_defaultImportPaths, d_C_defaultImportPathsWith, d_C_processArgsAndStart, d_C_getBanner, d_C_repl, d_C_calcPrompt, d_C_cleanUpRepl, d_C_processInput, d_C_evalExpression, d_C_importUnsafeModule, d_C_currentFrontendParams, d_C_writeSimpleMainGoalFile, d_C_writeMainGoalFile, d_C_cleanMainGoalFile, d_C_getAcyOfMainGoal, d_C_getAcyOfExpr, d_C_showTypeOfGoal, d_C_getModuleOfFunction, d_C_compileProgramWithGoal, d_C_insertFreeVarsInMainGoal, d_C_makeMainGoalMonomorphic, d_C_compileCurryProgram, d_C_execMain, d_C_processCommand, d_C_unsafeExec, nd_C_unsafeExec, d_C_replCommands, nd_C_replCommands, d_C_skipCommand, d_C_processSysCall, d_C_processQuit, d_C_processHelp, d_C_processLoad, d_C_processReload, d_C_processAdd, d_C_validModuleName, d_C_processEval, d_C_processType, d_C_processCd, d_C_processPrograms, d_C_processEdit, d_C_processSource, d_C_getModuleName, d_C_processShow, d_C_processInterface, d_C_processBrowse, d_C_processUsedImports, d_C_processSave, d_C_processFork, d_C_processSetOption, d_C_availOptions, nd_C_availOptions, d_C_replOptions, nd_C_replOptions, d_C_setPrompt, d_C_setNoGhci, d_C_setOptionPath, d_C_setOptionNDMode, nd_C_setOptionNDMode, d_C_setOptionSupply, d_C_printOptions, d_C_ifLocal, d_C_ifProfiling, d_C_showCurrentOptions, d_C_printHelpOnCommands, d_C_printAllLoadPathPrograms, d_C_showFunctionInModule, d_C_callTool, d_C_errorMissingTool, d_C_readAndProcessSourceFileOptions, d_C_processSourceFileOptions, d_C_readSourceFileOptions, d_C_terminateSourceProgGUIs) where

import Basics
import qualified Curry_AbstractCurry
import qualified Curry_AbstractCurryGoodies
import qualified Curry_Char
import qualified Curry_Directory
import qualified Curry_Distribution
import qualified Curry_FilePath
import qualified Curry_Files
import qualified Curry_FlatCurry
import qualified Curry_FlatCurryGoodies
import qualified Curry_GhciComm
import qualified Curry_IO
import qualified Curry_IOExts
import qualified Curry_Installation
import qualified Curry_Linker
import qualified Curry_List
import qualified Curry_Names
import qualified Curry_Prelude
import qualified Curry_RCFile
import qualified Curry_ReadNumeric
import qualified Curry_ReadShowTerm
import qualified Curry_Sort
import qualified Curry_System
import qualified Curry_Time
import qualified Curry_Utils

data C_GoalCompile
     = C_GoalError
     | C_GoalWithoutBindings Curry_AbstractCurry.C_CurryProg
     | C_GoalWithBindings Curry_AbstractCurry.C_CurryProg Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)
     | Choice_C_GoalCompile Cover ID C_GoalCompile C_GoalCompile
     | Choices_C_GoalCompile Cover ID ([C_GoalCompile])
     | Fail_C_GoalCompile Cover FailInfo
     | Guard_C_GoalCompile Cover Constraints C_GoalCompile

instance Show C_GoalCompile where
  showsPrec d (Choice_C_GoalCompile cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoalCompile cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoalCompile cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoalCompile cd info) = showChar '!'
  showsPrec _ C_GoalError = showString "GoalError"
  showsPrec _ (C_GoalWithoutBindings x1) = (showString "(GoalWithoutBindings") . ((showChar ' ') . ((shows x1) . (showChar ')')))
  showsPrec _ (C_GoalWithBindings x1 x2 x3) = (showString "(GoalWithBindings") . ((showChar ' ') . ((shows x1) . ((showChar ' ') . ((shows x2) . ((showChar ' ') . ((shows x3) . (showChar ')')))))))


instance Read C_GoalCompile where
  readsPrec d s = (readParen False (\r -> [ (C_GoalError,r0) | (_,r0) <- readQualified "REPL" "GoalError" r]) s) ++ ((readParen (d > 10) (\r -> [ (C_GoalWithoutBindings x1,r1) | (_,r0) <- readQualified "REPL" "GoalWithoutBindings" r, (x1,r1) <- readsPrec 11 r0]) s) ++ (readParen (d > 10) (\r -> [ (C_GoalWithBindings x1 x2 x3,r3) | (_,r0) <- readQualified "REPL" "GoalWithBindings" r, (x1,r1) <- readsPrec 11 r0, (x2,r2) <- readsPrec 11 r1, (x3,r3) <- readsPrec 11 r2]) s))


instance NonDet C_GoalCompile where
  choiceCons = Choice_C_GoalCompile
  choicesCons = Choices_C_GoalCompile
  failCons = Fail_C_GoalCompile
  guardCons = Guard_C_GoalCompile
  try (Choice_C_GoalCompile cd i x y) = tryChoice cd i x y
  try (Choices_C_GoalCompile cd i xs) = tryChoices cd i xs
  try (Fail_C_GoalCompile cd info) = Fail cd info
  try (Guard_C_GoalCompile cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoalCompile cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoalCompile cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_GoalCompile cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoalCompile cd i _) = error ("REPL.GoalCompile.match: Choices with ChoiceID " ++ (show i))
  match _ _ _ f _ _ (Fail_C_GoalCompile cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoalCompile cd c e) = f cd c e
  match _ _ _ _ _ f x = f x


instance Generable C_GoalCompile where
  generate s c = Choices_C_GoalCompile c (freeID [0,1,3] s) [C_GoalError,(C_GoalWithoutBindings (generate (leftSupply s) c)),(C_GoalWithBindings (generate (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate (rightSupply s) c))]


instance NormalForm C_GoalCompile where
  ($!!) cont C_GoalError d cs = cont C_GoalError d cs
  ($!!) cont (C_GoalWithoutBindings x1) d cs = (((\y1 d cs -> cont (C_GoalWithoutBindings y1) d cs) $!! x1) d) cs
  ($!!) cont (C_GoalWithBindings x1 x2 x3) d cs = (((\y1 d cs -> (((\y2 d cs -> (((\y3 d cs -> cont (C_GoalWithBindings y1 y2 y3) d cs) $!! x3) d) cs) $!! x2) d) cs) $!! x1) d) cs
  ($!!) cont (Choice_C_GoalCompile cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_GoalCompile cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GoalCompile cd c e) d cs = guardCons cd c (((cont $!! e) d) (addCs c cs))
  ($!!) _ (Fail_C_GoalCompile cd info) _ _ = failCons cd info
  ($##) cont C_GoalError d cs = cont C_GoalError d cs
  ($##) cont (C_GoalWithoutBindings x1) d cs = (((\y1 d cs -> cont (C_GoalWithoutBindings y1) d cs) $## x1) d) cs
  ($##) cont (C_GoalWithBindings x1 x2 x3) d cs = (((\y1 d cs -> (((\y2 d cs -> (((\y3 d cs -> cont (C_GoalWithBindings y1 y2 y3) d cs) $## x3) d) cs) $## x2) d) cs) $## x1) d) cs
  ($##) cont (Choice_C_GoalCompile cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_GoalCompile cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_GoalCompile cd c e) d cs = guardCons cd c (((cont $## e) d) (addCs c cs))
  ($##) _ (Fail_C_GoalCompile cd info) _ _ = failCons cd info
  showCons C_GoalError = "REPL.GoalError"
  showCons (C_GoalWithoutBindings _) = "REPL.GoalWithoutBindings _"
  showCons (C_GoalWithBindings _ _ _) = "REPL.GoalWithBindings _ _ _"
  showCons x = error ("REPL.GoalCompile.showCons: no constructor: " ++ (show x))
  searchNF _ cont C_GoalError = cont C_GoalError
  searchNF search cont (C_GoalWithoutBindings x1) = search (\y1 -> cont (C_GoalWithoutBindings y1)) x1
  searchNF search cont (C_GoalWithBindings x1 x2 x3) = search (\y1 -> search (\y2 -> search (\y3 -> cont (C_GoalWithBindings y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error ("REPL.GoalCompile.searchNF: no constructor: " ++ (show x))


instance Unifiable C_GoalCompile where
  (=.=) C_GoalError C_GoalError d cs = C_Success
  (=.=) (C_GoalWithoutBindings x1) (C_GoalWithoutBindings y1) d cs = ((x1 =:= y1) d) cs
  (=.=) (C_GoalWithBindings x1 x2 x3) (C_GoalWithBindings y1 y2 y3) d cs = (((((x1 =:= y1) d) cs) & ((((((x2 =:= y2) d) cs) & (((x3 =:= y3) d) cs)) d) cs)) d) cs
  (=.=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_GoalError C_GoalError d cs = C_Success
  (=.<=) (C_GoalWithoutBindings x1) (C_GoalWithoutBindings y1) d cs = ((x1 =:<= y1) d) cs
  (=.<=) (C_GoalWithBindings x1 x2 x3) (C_GoalWithBindings y1 y2 y3) d cs = (((((x1 =:<= y1) d) cs) & ((((((x2 =:<= y2) d) cs) & (((x3 =:<= y3) d) cs)) d) cs)) d) cs
  (=.<=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  bind cd i C_GoalError = ((i :=: (ChooseN 0 0)):(concat []))
  bind cd i (C_GoalWithoutBindings x3) = ((i :=: (ChooseN 1 1)):(concat [(bind cd (leftID i) x3)]))
  bind cd i (C_GoalWithBindings x3 x4 x5) = ((i :=: (ChooseN 2 3)):(concat [(bind cd (leftID (leftID i)) x3),(bind cd (rightID (leftID i)) x4),(bind cd (rightID i) x5)]))
  bind d i (Choice_C_GoalCompile cd j x y) = [(ConstraintChoice cd j (bind d i x) (bind d i y))]
  bind d i (Choices_C_GoalCompile cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_GoalCompile cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (bind d i) xs))]
  bind _ _ (Choices_C_GoalCompile cd i _) = error ("REPL.GoalCompile.bind: Choices with ChoiceID: " ++ (show i))
  bind _ _ (Fail_C_GoalCompile cd info) = [(Unsolvable info)]
  bind d i (Guard_C_GoalCompile cd c e) = (getConstrList c) ++ (bind d i e)
  lazyBind cd i C_GoalError = [(i :=: (ChooseN 0 0))]
  lazyBind cd i (C_GoalWithoutBindings x3) = [(i :=: (ChooseN 1 1)),((leftID i) :=: (LazyBind (lazyBind cd (leftID i) x3)))]
  lazyBind cd i (C_GoalWithBindings x3 x4 x5) = [(i :=: (ChooseN 2 3)),((leftID (leftID i)) :=: (LazyBind (lazyBind cd (leftID (leftID i)) x3))),((rightID (leftID i)) :=: (LazyBind (lazyBind cd (rightID (leftID i)) x4))),((rightID i) :=: (LazyBind (lazyBind cd (rightID i) x5)))]
  lazyBind d i (Choice_C_GoalCompile cd j x y) = [(ConstraintChoice cd j (lazyBind d i x) (lazyBind d i y))]
  lazyBind d i (Choices_C_GoalCompile cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_GoalCompile cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (lazyBind d i) xs))]
  lazyBind _ _ (Choices_C_GoalCompile cd i _) = error ("REPL.GoalCompile.lazyBind: Choices with ChoiceID: " ++ (show i))
  lazyBind _ _ (Fail_C_GoalCompile cd info) = [(Unsolvable info)]
  lazyBind d i (Guard_C_GoalCompile cd c e) = (getConstrList c) ++ [(i :=: (LazyBind (lazyBind d i e)))]


instance Curry_Prelude.Curry C_GoalCompile where
  (=?=) (Choice_C_GoalCompile cd i x y) z d cs = narrow cd i (((x Curry_Prelude.=?= z) d) cs) (((y Curry_Prelude.=?= z) d) cs)
  (=?=) (Choices_C_GoalCompile cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.=?= y) d) cs) xs
  (=?=) (Guard_C_GoalCompile cd c e) y d cs = guardCons cd c (((e Curry_Prelude.=?= y) d) (addCs c cs))
  (=?=) (Fail_C_GoalCompile cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_GoalCompile cd i x y) d cs = narrow cd i (((z Curry_Prelude.=?= x) d) cs) (((z Curry_Prelude.=?= y) d) cs)
  (=?=) y (Choices_C_GoalCompile cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.=?= x) d) cs) xs
  (=?=) y (Guard_C_GoalCompile cd c e) d cs = guardCons cd c (((y Curry_Prelude.=?= e) d) (addCs c cs))
  (=?=) _ (Fail_C_GoalCompile cd info) _ _ = failCons cd info
  (=?=) C_GoalError C_GoalError d cs = Curry_Prelude.C_True
  (=?=) (C_GoalWithoutBindings x1) (C_GoalWithoutBindings y1) d cs = ((x1 Curry_Prelude.=?= y1) d) cs
  (=?=) (C_GoalWithBindings x1 x2 x3) (C_GoalWithBindings y1 y2 y3) d cs = Curry_Prelude.d_OP_amp_amp (((x1 Curry_Prelude.=?= y1) d) cs) (Curry_Prelude.d_OP_amp_amp (((x2 Curry_Prelude.=?= y2) d) cs) (((x3 Curry_Prelude.=?= y3) d) cs) d cs) d cs
  (=?=) _ _ d _ = Curry_Prelude.C_False
  (<?=) (Choice_C_GoalCompile cd i x y) z d cs = narrow cd i (((x Curry_Prelude.<?= z) d) cs) (((y Curry_Prelude.<?= z) d) cs)
  (<?=) (Choices_C_GoalCompile cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.<?= y) d) cs) xs
  (<?=) (Guard_C_GoalCompile cd c e) y d cs = guardCons cd c (((e Curry_Prelude.<?= y) d) (addCs c cs))
  (<?=) (Fail_C_GoalCompile cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_GoalCompile cd i x y) d cs = narrow cd i (((z Curry_Prelude.<?= x) d) cs) (((z Curry_Prelude.<?= y) d) cs)
  (<?=) y (Choices_C_GoalCompile cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.<?= x) d) cs) xs
  (<?=) y (Guard_C_GoalCompile cd c e) d cs = guardCons cd c (((y Curry_Prelude.<?= e) d) (addCs c cs))
  (<?=) _ (Fail_C_GoalCompile cd info) _ _ = failCons cd info
  (<?=) C_GoalError C_GoalError d cs = Curry_Prelude.C_True
  (<?=) C_GoalError (C_GoalWithoutBindings _) _ _ = Curry_Prelude.C_True
  (<?=) C_GoalError (C_GoalWithBindings _ _ _) _ _ = Curry_Prelude.C_True
  (<?=) (C_GoalWithoutBindings x1) (C_GoalWithoutBindings y1) d cs = ((x1 Curry_Prelude.<?= y1) d) cs
  (<?=) (C_GoalWithoutBindings _) (C_GoalWithBindings _ _ _) _ _ = Curry_Prelude.C_True
  (<?=) (C_GoalWithBindings x1 x2 x3) (C_GoalWithBindings y1 y2 y3) d cs = Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_lt x1 y1 d cs) (Curry_Prelude.d_OP_amp_amp (((x1 Curry_Prelude.=?= y1) d) cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_lt x2 y2 d cs) (Curry_Prelude.d_OP_amp_amp (((x2 Curry_Prelude.=?= y2) d) cs) (((x3 Curry_Prelude.<?= y3) d) cs) d cs) d cs) d cs) d cs
  (<?=) _ _ d _ = Curry_Prelude.C_False


d_C_writeErrorMsg :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeErrorMsg x1 cd cs = Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "ERROR: ") x1 cd cs) cd cs

d_C_main :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_main cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_RCFile.d_C_readRC cd cs) d_OP_main_dot_uscore_hash_lambda1 cd cs

d_OP_main_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda1 x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_System.d_C_getArgs cd cs) (d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1) cd cs

d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 cd cs = let
     x3 = Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_rcvars (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_kics2Home (Curry_Linker.d_C_initReplState cd cs) (Curry_Installation.d_C_installDir cd cs) cd cs) x1 cd cs
      in (Curry_Prelude.d_OP_gt_gt_eq (d_C_defaultImportPaths x3 cd cs) (d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 x2 x3) cd cs)

d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 x1 x2 x3 cd cs = d_C_processArgsAndStart (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_importPaths x2 x3 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map (Curry_Utils.d_C_strip cd cs) (Curry_Prelude.d_C_words (Curry_RCFile.d_C_rcValue (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rcvars x2 cd cs) (Curry_Prelude.toCurryString "defaultparams") cd cs) cd cs) cd cs) x1 cd cs) cd cs

d_C_defaultImportPaths :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_defaultImportPaths x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_System.d_C_getEnviron (Curry_Prelude.toCurryString "CURRYPATH") cd cs) (d_OP_defaultImportPaths_dot_uscore_hash_lambda4 x1) cd cs

d_OP_defaultImportPaths_dot_uscore_hash_lambda4 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_defaultImportPaths_dot_uscore_hash_lambda4 x1 x2 cd cs = let
     x3 = Curry_RCFile.d_C_rcValue (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rcvars x1 cd cs) (Curry_Prelude.toCurryString "libraries") cd cs
      in (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_filter (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_slash_eq) (Curry_Prelude.toCurryString "."))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (Curry_FilePath.d_C_splitSearchPath cd cs) x2 cd cs) (Curry_Prelude.d_C_apply (Curry_FilePath.d_C_splitSearchPath cd cs) x3 cd cs) cd cs) cd cs) cd cs)

d_C_defaultImportPathsWith :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_defaultImportPathsWith x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_defaultImportPaths x1 cd cs) (d_OP_defaultImportPathsWith_dot_uscore_hash_lambda5 x2) cd cs

d_OP_defaultImportPathsWith_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_defaultImportPathsWith_dot_uscore_hash_lambda5 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapIO Curry_Directory.d_C_getAbsolutePath cd cs) (Curry_Prelude.d_C_apply (Curry_FilePath.d_C_splitSearchPath cd cs) x1 cd cs) cd cs) (d_OP_defaultImportPathsWith_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x2) cd cs

d_OP_defaultImportPathsWith_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_defaultImportPathsWith_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.d_OP_plus_plus x2 x1 cd cs) cd cs

d_C_processArgsAndStart :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_processArgsAndStart x1 x2 cd cs = case x2 of
     Curry_Prelude.OP_List -> d_C__case_140 x1 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_quit x1 cd cs) cd cs
     (Curry_Prelude.OP_Cons x3 x4) -> let
          x5 = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_putStrLn (Curry_Prelude.toCurryString "Usage: kics2 <list of commands>\n") cd cs) (d_C_printHelpOnCommands cd cs) cd cs
           in (d_C__case_138 x3 x4 x5 x1 (Curry_Prelude.d_OP_slash_eq (Curry_Prelude.d_C_head x3 cd cs) (Curry_Prelude.C_Char ':'#) cd cs) cd cs)
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_processArgsAndStart x1 l cd cs) (d_C_processArgsAndStart x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_processArgsAndStart x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_processArgsAndStart x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL.processArgsAndStart" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.processArgsAndStart" (showCons x2))

d_OP_processArgsAndStart_dot_uscore_hash_lambda7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_processArgsAndStart_dot_uscore_hash_lambda7 x1 cd cs = Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_head x1 cd cs) (Curry_Prelude.C_Char ':'#) cd cs

d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs l cd cs) (d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processArgsAndStart._#selFP2#cmdargs" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processArgsAndStart._#selFP2#cmdargs" (showCons x1))

d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more l cd cs) (d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processArgsAndStart._#selFP3#more" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processArgsAndStart._#selFP3#more" (showCons x1))

d_OP_processArgsAndStart_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit -> Curry_Prelude.C_Maybe Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_processArgsAndStart_dot_uscore_hash_lambda8 x1 x2 x3 cd cs = Curry_Prelude.d_C_maybe x2 (d_OP_processArgsAndStart_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1) x3 cd cs

nd_OP_processArgsAndStart_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit -> Curry_Prelude.C_Maybe Curry_Linker.C_ReplState -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_processArgsAndStart_dot_uscore_hash_lambda8 x1 x2 x3 s cd cs = let
     s0 = s
      in (seq s0 (Curry_Prelude.nd_C_maybe x2 (wrapDX id (d_OP_processArgsAndStart_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1)) x3 s0 cd cs))

d_OP_processArgsAndStart_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_processArgsAndStart_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 cd cs = d_C_processArgsAndStart x2 x1 cd cs

d_C_getBanner :: Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getBanner cd cs = let
     x1 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Version ") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show (Curry_Installation.d_C_majorVersion cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ".") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show (Curry_Installation.d_C_minorVersion cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ".") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show (Curry_Installation.d_C_revisionVersion cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " of ") (Curry_Prelude.d_OP_plus_plus (Curry_Installation.d_C_compilerDate cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " (installed at ") (Curry_Prelude.d_OP_plus_plus (Curry_Installation.d_C_installDate cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
      in (Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_readFile (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Installation.d_C_installDir cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "include") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_dot_gt cd cs) (Curry_Prelude.toCurryString "logo") cd cs) (Curry_Prelude.toCurryString "txt") cd cs) cd cs) cd cs) cd cs) (d_OP_getBanner_dot_uscore_hash_lambda10 x1) cd cs)

d_OP_getBanner_dot_uscore_hash_lambda10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getBanner_dot_uscore_hash_lambda10 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.d_OP_plus_plus x2 x1 cd cs) cd cs

d_C_repl :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_repl x1 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_putStr (d_C_calcPrompt x1 cd cs) cd cs) (Curry_IO.d_C_hFlush (Curry_IO.d_C_stdout cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt_eq (Curry_IO.d_C_isEOF cd cs) (d_OP_repl_dot_uscore_hash_lambda11 x1) cd cs) cd cs

d_OP_repl_dot_uscore_hash_lambda11 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_repl_dot_uscore_hash_lambda11 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> d_C_cleanUpRepl x1 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_getLine cd cs) (Curry_Prelude.d_OP_dot (d_C_processInput x1) (Curry_Utils.d_C_strip cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_OP_repl_dot_uscore_hash_lambda11 x1 l cd cs) (d_OP_repl_dot_uscore_hash_lambda11 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_OP_repl_dot_uscore_hash_lambda11 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_OP_repl_dot_uscore_hash_lambda11 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.repl._#lambda11" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.repl._#lambda11" (showCons x2))

d_C_calcPrompt :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_calcPrompt x1 cd cs = let
     x2 = Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_addMods x1 cd cs)) cd cs
      in (d_OP_calcPrompt_dot_subst_dot_39 x2 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_prompt x1 cd cs) cd cs)

d_OP_calcPrompt_dot_subst_dot_39 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_calcPrompt_dot_subst_dot_39 x1 x2 cd cs = case x2 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x3 x4) -> d_C__case_137 x3 x1 x4 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_calcPrompt_dot_subst_dot_39 x1 l cd cs) (d_OP_calcPrompt_dot_subst_dot_39 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_calcPrompt_dot_subst_dot_39 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_calcPrompt_dot_subst_dot_39 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL.calcPrompt.subst.39" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.calcPrompt.subst.39" (showCons x2))

d_C_cleanUpRepl :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_cleanUpRepl x1 cd cs = Curry_Prelude.d_OP_gt_gt (d_C_terminateSourceProgGUIs x1 cd cs) (Curry_System.d_C_exitWith (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_exitStatus x1 cd cs) cd cs) cd cs

d_C_processInput :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_processInput x1 x2 cd cs = d_C__case_133 x2 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs

d_OP_processInput_dot_isCommand_dot_62 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_processInput_dot_isCommand_dot_62 x1 cd cs = Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply (Curry_Utils.d_C_notNull cd cs) x1 cd cs) (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_head x1 cd cs) (Curry_Prelude.C_Char ':'#) cd cs) cd cs

d_OP_processInput_dot_uscore_hash_lambda14 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Maybe Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_processInput_dot_uscore_hash_lambda14 x1 x2 cd cs = Curry_Prelude.d_C_maybe (d_C_repl (Curry_Linker.d_C_setExitStatus (Curry_Prelude.C_Int 1#) x1 cd cs) cd cs) d_OP_processInput_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x2 cd cs

d_OP_processInput_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_processInput_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 cd cs = d_C__case_130 x1 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_quit x1 cd cs) cd cs

d_C_evalExpression :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_C_evalExpression x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_compileProgramWithGoal x1 (Curry_Prelude.d_C_not (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_useGhci x1 cd cs) cd cs) x2 cd cs) (d_OP_evalExpression_dot_uscore_hash_lambda16 x2) cd cs

d_OP_evalExpression_dot_uscore_hash_lambda16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_OP_evalExpression_dot_uscore_hash_lambda16 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_Prelude.d_OP_gt_gt_eq (d_C__case_129 x3 x4 x1 (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_eq_eq x4 Curry_Linker.C_MainError cd cs) (Curry_Prelude.d_OP_amp_amp (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_useGhci x3 cd cs) (Curry_Prelude.d_C_not (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_interactive x3 cd cs) cd cs) cd cs) cd cs) cd cs) d_OP_evalExpression_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_evalExpression_dot_uscore_hash_lambda16 x1 l cd cs) (d_OP_evalExpression_dot_uscore_hash_lambda16 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_evalExpression_dot_uscore_hash_lambda16 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_evalExpression_dot_uscore_hash_lambda16 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.evalExpression._#lambda16" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.evalExpression._#lambda16" (showCons x2))

d_OP_evalExpression_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_OP_evalExpression_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 x1 cd cs = Curry_Prelude.d_OP_gt_gt (d_C_cleanMainGoalFile x1 cd cs) (Curry_Prelude.d_C_return x1 cd cs) cd cs

d_C_importUnsafeModule :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_importUnsafeModule x1 cd cs = d_C__case_128 x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem (Curry_Prelude.toCurryString "Unsafe") cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_addMods x1 cd cs) cd cs) cd cs

d_OP_importUnsafeModule_dot_uscore_hash_lambda18 :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_OP_importUnsafeModule_dot_uscore_hash_lambda18 x1 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem (Curry_Prelude.toCurryString "Unsafe") cd cs) (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_progImports cd cs) x1 cd cs) cd cs) cd cs

d_OP_importUnsafeModule_dot_uscore_hash_lambda19 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_IOError -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_OP_importUnsafeModule_dot_uscore_hash_lambda19 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.d_OP_slash_eq (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) (Curry_Prelude.toCurryString "Prelude") cd cs) cd cs

d_C_currentFrontendParams :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Distribution.C_FrontendParams
d_C_currentFrontendParams x1 cd cs = Curry_Prelude.d_OP_dollar (Curry_Distribution.d_C_setQuiet Curry_Prelude.C_True) (Curry_Prelude.d_OP_dollar (Curry_Distribution.d_C_setFullPath (Curry_Linker.d_C_loadPaths x1 cd cs)) (Curry_Prelude.d_OP_dollar (Curry_Distribution.d_C_setExtended (Curry_Prelude.d_OP_slash_eq (Curry_RCFile.d_C_rcValue (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rcvars x1 cd cs) (Curry_Prelude.toCurryString "curryextensions") cd cs) (Curry_Prelude.toCurryString "no") cd cs)) (Curry_Prelude.d_OP_dollar (Curry_Distribution.d_C_setOverlapWarn (Curry_Prelude.d_OP_slash_eq (Curry_RCFile.d_C_rcValue (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rcvars x1 cd cs) (Curry_Prelude.toCurryString "warnoverlapping") cd cs) (Curry_Prelude.toCurryString "no") cd cs)) (Curry_Distribution.d_C_setSpecials (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_parseOpts x1 cd cs) (Curry_Distribution.d_C_defaultParams cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

d_C_writeSimpleMainGoalFile :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeSimpleMainGoalFile x1 x2 cd cs = d_C_writeMainGoalFile x1 Curry_Prelude.OP_List Curry_Prelude.C_Nothing x2 cd cs

d_C_writeMainGoalFile :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeMainGoalFile x1 x2 x3 x4 cd cs = let
     x5 = Curry_Prelude.d_OP_dollar Curry_List.d_C_nub (Curry_Prelude.OP_Cons (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_addMods x1 cd cs) x2 cd cs)) cd cs
     x6 = Curry_Prelude.toCurryString "{-# OPTIONS_CYMAKE -W no-missing-signatures #-}"
      in (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_writeFile (Curry_Linker.d_C_mainGoalFile cd cs)) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_unlines (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons x6 Curry_Prelude.OP_List) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "import ")) x5 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_maybe Curry_Prelude.OP_List d_OP_writeMainGoalFile_dot_uscore_hash_lambda20 x3 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "kics2MainGoal = ") x4 cd cs) Curry_Prelude.OP_List) cd cs) cd cs) cd cs) cd cs) cd cs)

d_OP_writeMainGoalFile_dot_uscore_hash_lambda20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_writeMainGoalFile_dot_uscore_hash_lambda20 x1 cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "kics2MainGoal :: ") x1 cd cs) Curry_Prelude.OP_List

d_C_cleanMainGoalFile :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_cleanMainGoalFile x1 cd cs = let
     x2 = Curry_Prelude.d_OP_eq_eq (Curry_RCFile.d_C_rcValue (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rcvars x1 cd cs) (Curry_Prelude.toCurryString "keepfiles") cd cs) (Curry_Prelude.toCurryString "yes") cd cs
      in (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless x2) (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar Curry_System.d_C_system (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Installation.d_C_installDir cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "bin") cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "cleancurry ") (Curry_Linker.d_C_mainGoalFile cd cs) cd cs) cd cs) cd cs) cd cs) (Curry_Files.d_C_removeFileIfExists (Curry_Linker.d_C_mainGoalFile cd cs) cd cs) cd cs) cd cs)

d_C_getAcyOfMainGoal :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg)
d_C_getAcyOfMainGoal x1 cd cs = let
     x2 = Curry_Distribution.d_C_stripCurrySuffix (Curry_Linker.d_C_mainGoalFile cd cs) cd cs
     x3 = Curry_Prelude.d_OP_plus_plus (Curry_Distribution.d_C_inCurrySubdir (Curry_Distribution.d_C_stripCurrySuffix x2 cd cs) cd cs) (Curry_Prelude.toCurryString ".acy") cd cs
     x4 = d_C_currentFrontendParams x1 cd cs
      in (Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_catch (Curry_Prelude.d_OP_gt_gt (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_ACY x4 x2 cd cs) (Curry_AbstractCurry.d_C_tryReadACYFile x3 cd cs) cd cs) d_OP_getAcyOfMainGoal_dot_uscore_hash_lambda21 cd cs) (d_OP_getAcyOfMainGoal_dot_uscore_hash_lambda22 x3) cd cs)

d_OP_getAcyOfMainGoal_dot_uscore_hash_lambda21 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_IOError -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe t0)
d_OP_getAcyOfMainGoal_dot_uscore_hash_lambda21 x1 cd cs = Curry_Prelude.d_C_return Curry_Prelude.C_Nothing cd cs

d_OP_getAcyOfMainGoal_dot_uscore_hash_lambda22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg)
d_OP_getAcyOfMainGoal_dot_uscore_hash_lambda22 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Files.d_C_removeFileIfExists x1 cd cs) (Curry_Prelude.d_C_return x2 cd cs) cd cs

d_C_getAcyOfExpr :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg)
d_C_getAcyOfExpr x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (d_C_writeSimpleMainGoalFile x1 x2 cd cs) (Curry_Prelude.d_OP_gt_gt_eq (d_C_getAcyOfMainGoal x1 cd cs) d_OP_getAcyOfExpr_dot_uscore_hash_lambda23 cd cs) cd cs

d_OP_getAcyOfExpr_dot_uscore_hash_lambda23 :: Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg)
d_OP_getAcyOfExpr_dot_uscore_hash_lambda23 x1 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Files.d_C_removeFileIfExists (Curry_Linker.d_C_mainGoalFile cd cs) cd cs) (Curry_Prelude.d_C_return x1 cd cs) cd cs

d_C_showTypeOfGoal :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_showTypeOfGoal x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getAcyOfExpr x1 x2 cd cs) (d_OP_showTypeOfGoal_dot_uscore_hash_lambda24 x2) cd cs

d_OP_showTypeOfGoal_dot_uscore_hash_lambda24 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_OP_showTypeOfGoal_dot_uscore_hash_lambda24 x1 x2 cd cs = Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_return Curry_Prelude.C_False cd cs) (d_OP_showTypeOfGoal_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1) x2 cd cs

d_OP_showTypeOfGoal_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_OP_showTypeOfGoal_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 x2 cd cs = case x2 of
     (Curry_AbstractCurry.C_CurryProg x3 x4 x5 x6 x7) -> d_C__case_127 x1 x6 cd cs
     (Curry_AbstractCurry.Choice_C_CurryProg d i l r) -> narrow d i (d_OP_showTypeOfGoal_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 l cd cs) (d_OP_showTypeOfGoal_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 r cd cs)
     (Curry_AbstractCurry.Choices_C_CurryProg d i xs) -> narrows cs d i (\z -> d_OP_showTypeOfGoal_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CurryProg d c e) -> guardCons d c ((d_OP_showTypeOfGoal_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CurryProg d info) -> failCons d (traceFail "REPL.showTypeOfGoal._#lambda24._#lambda25" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.showTypeOfGoal._#lambda24._#lambda25" (showCons x2))

d_C_getModuleOfFunction :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getModuleOfFunction x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_OP_dollar (d_C_getAcyOfExpr x1) (d_C__case_124 x2 (Curry_Char.d_C_isAlpha (Curry_Prelude.d_C_head x2 cd cs) cd cs) cd cs) cd cs) d_OP_getModuleOfFunction_dot_uscore_hash_lambda27 cd cs

d_OP_getModuleOfFunction_dot_modOfMain_dot_117 :: Curry_AbstractCurry.C_CRules -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_getModuleOfFunction_dot_modOfMain_dot_117 x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CRules x2 x3) -> d_C__case_123 x3 cd cs
     (Curry_AbstractCurry.C_CExternal x42) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.Choice_C_CRules d i l r) -> narrow d i (d_OP_getModuleOfFunction_dot_modOfMain_dot_117 l cd cs) (d_OP_getModuleOfFunction_dot_modOfMain_dot_117 r cd cs)
     (Curry_AbstractCurry.Choices_C_CRules d i xs) -> narrows cs d i (\z -> d_OP_getModuleOfFunction_dot_modOfMain_dot_117 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CRules d c e) -> guardCons d c ((d_OP_getModuleOfFunction_dot_modOfMain_dot_117 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CRules d info) -> failCons d (traceFail "REPL.getModuleOfFunction.modOfMain.117" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.getModuleOfFunction.modOfMain.117" (showCons x1))

d_OP_getModuleOfFunction_dot_uscore_hash_lambda27 :: Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getModuleOfFunction_dot_uscore_hash_lambda27 x1 cd cs = Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return (Curry_Prelude.d_C_maybe Curry_Prelude.OP_List d_OP_getModuleOfFunction_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x1 cd cs) cd cs

d_OP_getModuleOfFunction_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 :: Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_getModuleOfFunction_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CurryProg x2 x3 x4 x5 x6) -> d_C__case_113 x5 cd cs
     (Curry_AbstractCurry.Choice_C_CurryProg d i l r) -> narrow d i (d_OP_getModuleOfFunction_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 l cd cs) (d_OP_getModuleOfFunction_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 r cd cs)
     (Curry_AbstractCurry.Choices_C_CurryProg d i xs) -> narrows cs d i (\z -> d_OP_getModuleOfFunction_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CurryProg d c e) -> guardCons d c ((d_OP_getModuleOfFunction_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CurryProg d info) -> failCons d (traceFail "REPL.getModuleOfFunction._#lambda27._#lambda28" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.getModuleOfFunction._#lambda27._#lambda28" (showCons x1))

d_C_compileProgramWithGoal :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_C_compileProgramWithGoal x1 x2 x3 cd cs = let
     x4 = Curry_Names.d_C_funcInfoFile (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_outputSubdir x1 cd cs) (Curry_Linker.d_C_mainModuleIdent cd cs) (Curry_Linker.d_C_mainGoalFile cd cs) cd cs
     x5 = Curry_Prelude.d_OP_gt_gt (Curry_Files.d_C_removeFileIfExists x4 cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar Curry_Files.d_C_removeFileIfExists (Curry_FlatCurry.d_C_flatCurryFileName (Curry_Linker.d_C_mainGoalFile cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (d_C_writeSimpleMainGoalFile x1 x3 cd cs) (Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_OP_gt_gt_eq (d_C_getAcyOfMainGoal x1 cd cs) (d_C_insertFreeVarsInMainGoal x1 x3) cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29 x2 x3 x4 x1) cd cs) cd cs) cd cs) cd cs
      in (d_C__case_110 x1 x5 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_safeExec x1 cd cs) cd cs)

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> C_GoalCompile -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29 x1 x2 x3 x4 x5 cd cs = d_C__case_109 x5 x2 x4 x3 x1 (Curry_Prelude.d_OP_eq_eq x5 C_GoalError cd cs) cd cs

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP5_hash_newprog :: Curry_Prelude.OP_Tuple3 Curry_AbstractCurry.C_CurryProg (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_AbstractCurry.C_CurryProg
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP5_hash_newprog x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> x2
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP5_hash_newprog l cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP5_hash_newprog r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP5_hash_newprog z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP5_hash_newprog e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "REPL.compileProgramWithGoal._#lambda29._#selFP5#newprog" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.compileProgramWithGoal._#lambda29._#selFP5#newprog" (showCons x1))

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP6_hash_newgoal :: Curry_Prelude.OP_Tuple3 Curry_AbstractCurry.C_CurryProg (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP6_hash_newgoal x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> x3
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP6_hash_newgoal l cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP6_hash_newgoal r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP6_hash_newgoal z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP6_hash_newgoal e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "REPL.compileProgramWithGoal._#lambda29._#selFP6#newgoal" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.compileProgramWithGoal._#lambda29._#selFP6#newgoal" (showCons x1))

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP7_hash_bindings :: Curry_Prelude.OP_Tuple3 Curry_AbstractCurry.C_CurryProg (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP7_hash_bindings x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> x4
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP7_hash_bindings l cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP7_hash_bindings r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP7_hash_bindings z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP7_hash_bindings e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "REPL.compileProgramWithGoal._#lambda29._#selFP7#bindings" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.compileProgramWithGoal._#lambda29._#selFP7#bindings" (showCons x1))

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 :: Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 x3 x4 x5 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_compileCurryProgram x5 (Curry_Linker.d_C_mainGoalFile cd cs) cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2 x3 x4 x5) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 (Curry_Linker.d_C_setExitStatus (Curry_Prelude.C_Int 1#) x5 cd cs) Curry_Linker.C_MainError) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 x3 x4 x5 l cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 x3 x4 x5 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 x3 x4 x5 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 x3 x4 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.compileProgramWithGoal._#lambda29._#lambda31" [(show x1),(show x2),(show x3),(show x4),(show x5),(show x6)] info)
     _ -> failCons cd (consFail "REPL.compileProgramWithGoal._#lambda29._#lambda31" (showCons x6))

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 :: Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32 x1 x2 x3 x4 x5 x6 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x4 cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32_dot_uscore_hash_lambda33 x1 x2 x3 x5 x6) cd cs

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32_dot_uscore_hash_lambda33 :: Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda32_dot_uscore_hash_lambda33 x1 x2 x3 x4 x5 x6 cd cs = d_C__case_107 x6 x5 x4 x1 x3 x2 (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_eq x5 (Curry_Prelude.C_Int 0#) cd cs) x6 cd cs) cd cs

d_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 :: Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile) -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (d_C_writeErrorMsg (Curry_Prelude.toCurryString "Import of 'Unsafe' not allowed in safe mode!") cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 (Curry_Linker.d_C_setExitStatus (Curry_Prelude.C_Int 1#) x2 cd cs) Curry_Linker.C_MainError) cd cs) cd cs
     Curry_Prelude.C_False -> x1
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 l cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.compileProgramWithGoal._#lambda34" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.compileProgramWithGoal._#lambda34" (showCons x3))

nd_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 :: Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile) -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
nd_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 x3 s cd cs = case x3 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_gt_gt (d_C_writeErrorMsg (Curry_Prelude.toCurryString "Import of 'Unsafe' not allowed in safe mode!") cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 (Curry_Linker.d_C_setExitStatus (Curry_Prelude.C_Int 1#) x2 cd cs) Curry_Linker.C_MainError) cd cs) s0 cd cs))
     Curry_Prelude.C_False -> x1
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 l s cd cs) (nd_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x1 x2 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.compileProgramWithGoal._#lambda34" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.compileProgramWithGoal._#lambda34" (showCons x3))

d_C_insertFreeVarsInMainGoal :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_C_insertFreeVarsInMainGoal x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_return C_GoalError cd cs
     (Curry_Prelude.C_Just x4) -> d_C__case_106 x2 x1 x4 cd cs
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C_insertFreeVarsInMainGoal x1 x2 l cd cs) (d_C_insertFreeVarsInMainGoal x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C_insertFreeVarsInMainGoal x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C_insertFreeVarsInMainGoal x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "REPL.insertFreeVarsInMainGoal" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.insertFreeVarsInMainGoal" (showCons x3))

d_OP_insertFreeVarsInMainGoal_dot_isPrtChoices_dot_167 :: Curry_Linker.C_NonDetMode -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_insertFreeVarsInMainGoal_dot_isPrtChoices_dot_167 x1 cd cs = case x1 of
     (Curry_Linker.C_PrtChoices x2) -> Curry_Prelude.C_True
     Curry_Linker.C_DFS -> Curry_Prelude.C_False
     Curry_Linker.C_BFS -> Curry_Prelude.C_False
     (Curry_Linker.C_IDS x3) -> Curry_Prelude.C_False
     (Curry_Linker.C_Par x4) -> Curry_Prelude.C_False
     Curry_Linker.C_PrDFS -> Curry_Prelude.C_False
     Curry_Linker.C_DEBUG -> Curry_Prelude.C_False
     (Curry_Linker.Choice_C_NonDetMode d i l r) -> narrow d i (d_OP_insertFreeVarsInMainGoal_dot_isPrtChoices_dot_167 l cd cs) (d_OP_insertFreeVarsInMainGoal_dot_isPrtChoices_dot_167 r cd cs)
     (Curry_Linker.Choices_C_NonDetMode d i xs) -> narrows cs d i (\z -> d_OP_insertFreeVarsInMainGoal_dot_isPrtChoices_dot_167 z cd cs) xs
     (Curry_Linker.Guard_C_NonDetMode d c e) -> guardCons d c ((d_OP_insertFreeVarsInMainGoal_dot_isPrtChoices_dot_167 e cd) $! (addCs c cs))
     (Curry_Linker.Fail_C_NonDetMode d info) -> failCons d (traceFail "REPL.insertFreeVarsInMainGoal.isPrtChoices.167" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.insertFreeVarsInMainGoal.isPrtChoices.167" (showCons x1))

d_OP_insertFreeVarsInMainGoal_dot_lvarName_dot_167 :: Curry_AbstractCurry.C_CLocalDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_insertFreeVarsInMainGoal_dot_lvarName_dot_167 x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CLocalVar x2) -> d_C__case_100 x2 cd cs
     (Curry_AbstractCurry.C_CLocalFunc x5) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CLocalPat x6 x7 x8) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.Choice_C_CLocalDecl d i l r) -> narrow d i (d_OP_insertFreeVarsInMainGoal_dot_lvarName_dot_167 l cd cs) (d_OP_insertFreeVarsInMainGoal_dot_lvarName_dot_167 r cd cs)
     (Curry_AbstractCurry.Choices_C_CLocalDecl d i xs) -> narrows cs d i (\z -> d_OP_insertFreeVarsInMainGoal_dot_lvarName_dot_167 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CLocalDecl d c e) -> guardCons d c ((d_OP_insertFreeVarsInMainGoal_dot_lvarName_dot_167 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CLocalDecl d info) -> failCons d (traceFail "REPL.insertFreeVarsInMainGoal.lvarName.167" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.insertFreeVarsInMainGoal.lvarName.167" (showCons x1))

d_OP_insertFreeVarsInMainGoal_dot_freeVarsInFuncRule_dot_167 :: Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_insertFreeVarsInMainGoal_dot_freeVarsInFuncRule_dot_167 x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CFunc x2 x3 x4 x5 x6) -> d_C__case_99 x6 cd cs
     (Curry_AbstractCurry.C_CmtFunc x17 x18 x19 x20 x21 x22) -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.insertFreeVarsInMainGoal.freeVarsInFuncRule") cd cs
     (Curry_AbstractCurry.Choice_C_CFuncDecl d i l r) -> narrow d i (d_OP_insertFreeVarsInMainGoal_dot_freeVarsInFuncRule_dot_167 l cd cs) (d_OP_insertFreeVarsInMainGoal_dot_freeVarsInFuncRule_dot_167 r cd cs)
     (Curry_AbstractCurry.Choices_C_CFuncDecl d i xs) -> narrows cs d i (\z -> d_OP_insertFreeVarsInMainGoal_dot_freeVarsInFuncRule_dot_167 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CFuncDecl d c e) -> guardCons d c ((d_OP_insertFreeVarsInMainGoal_dot_freeVarsInFuncRule_dot_167 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CFuncDecl d info) -> failCons d (traceFail "REPL.insertFreeVarsInMainGoal.freeVarsInFuncRule.167" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.insertFreeVarsInMainGoal.freeVarsInFuncRule.167" (showCons x1))

d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167 x1 cd cs = let
     x2 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x1 cd cs
      in (d_C__case_95 x2 x1 (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_take (Curry_Prelude.C_Int 4#) x2 cd cs) (Curry_Prelude.toCurryString "eerf") cd cs) cd cs)

d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 x1 cd cs = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x2 x3) -> d_C__case_93 x3 x2 (Curry_Prelude.d_OP_amp_amp (Curry_Char.d_C_isSpace x2 cd cs) (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_take (Curry_Prelude.C_Int 6#) x3 cd cs) (Curry_Prelude.toCurryString "erehw ") cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 l cd cs) (d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL.insertFreeVarsInMainGoal.breakWhereFreeClause.167.findWhere.199" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.insertFreeVarsInMainGoal.breakWhereFreeClause.167.findWhere.199" (showCons x1))

d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP9_hash_exp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP9_hash_exp x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP9_hash_exp l cd cs) (d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP9_hash_exp r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP9_hash_exp z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP9_hash_exp e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.insertFreeVarsInMainGoal._#selFP9#exp" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.insertFreeVarsInMainGoal._#selFP9#exp" (showCons x1))

d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP10_hash_whereclause :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP10_hash_whereclause x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP10_hash_whereclause l cd cs) (d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP10_hash_whereclause r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP10_hash_whereclause z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP10_hash_whereclause e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.insertFreeVarsInMainGoal._#selFP10#whereclause" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.insertFreeVarsInMainGoal._#selFP10#whereclause" (showCons x1))

d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda39 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda39 x1 cd cs = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\"") (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "\"") cd cs) cd cs

d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda40 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda40 x1 cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ','#) x1

d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda41 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda41 x1 x2 x3 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.d_C_maybe C_GoalError (d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda41_dot_uscore_hash_lambda42 x1 x2) x3 cd cs) cd cs

d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda41_dot_uscore_hash_lambda42 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> C_GoalCompile
d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda41_dot_uscore_hash_lambda42 x1 x2 x3 cd cs = C_GoalWithBindings x3 (Curry_Prelude.d_C_length x1 cd cs) x2

d_C_makeMainGoalMonomorphic :: Curry_Linker.C_ReplState -> Curry_AbstractCurry.C_CurryProg -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_makeMainGoalMonomorphic x1 x2 x3 cd cs = case x2 of
     (Curry_AbstractCurry.C_CurryProg x4 x5 x6 x7 x8) -> d_C__case_91 x3 x1 x7 cd cs
     (Curry_AbstractCurry.Choice_C_CurryProg d i l r) -> narrow d i (d_C_makeMainGoalMonomorphic x1 l x3 cd cs) (d_C_makeMainGoalMonomorphic x1 r x3 cd cs)
     (Curry_AbstractCurry.Choices_C_CurryProg d i xs) -> narrows cs d i (\z -> d_C_makeMainGoalMonomorphic x1 z x3 cd cs) xs
     (Curry_AbstractCurry.Guard_C_CurryProg d c e) -> guardCons d c ((d_C_makeMainGoalMonomorphic x1 e x3 cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CurryProg d info) -> failCons d (traceFail "REPL.makeMainGoalMonomorphic" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.makeMainGoalMonomorphic" (showCons x2))

d_OP_makeMainGoalMonomorphic_dot_newgoal_dot_237 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_makeMainGoalMonomorphic_dot_newgoal_dot_237 x1 x2 cd cs = d_C__case_85 x2 x1 (Curry_AbstractCurryGoodies.d_C_isIOReturnType x2 cd cs) cd cs

d_C_compileCurryProgram :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C_compileCurryProgram x1 x2 cd cs = let
     x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_kics2Home x1 cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "bin") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString ".local") cd cs) (Curry_Prelude.toCurryString "kics2c") cd cs) cd cs) cd cs
     x4 = Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_unwords (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "-v") (Curry_Prelude.d_C_show (d_OP_compileCurryProgram_dot_transVerbose_dot_256 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_verbose x1 cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "-i") (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ":") (Curry_Linker.d_C_loadPaths x1 cd cs) cd cs) cd cs) Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_plus_plus (d_C__case_84 x1 (Curry_Prelude.d_C_null (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_parseOpts x1 cd cs) cd cs) cd cs) (d_C__case_83 x1 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_traceFailure x1 cd cs) cd cs) cd cs) cd cs) cd cs
     x5 = Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x3 (Curry_Prelude.OP_Cons x4 (Curry_Prelude.OP_Cons (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_cmpOpts x1 cd cs) (Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List)))) cd cs
      in (Curry_Prelude.d_OP_gt_gt_eq (Curry_Linker.d_C_getTimeCmd x1 (Curry_Prelude.toCurryString "KiCS2 compilation") x5 cd cs) (d_OP_compileCurryProgram_dot_uscore_hash_lambda45 x1) cd cs)

d_OP_compileCurryProgram_dot_transVerbose_dot_256 :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_compileCurryProgram_dot_transVerbose_dot_256 x1 cd cs = d_C__case_82 x1 (Curry_Prelude.d_OP_eq_eq x1 (Curry_Prelude.C_Int 3#) cd cs) cd cs

d_OP_compileCurryProgram_dot_uscore_hash_lambda45 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_OP_compileCurryProgram_dot_uscore_hash_lambda45 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 2#)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Executing: ") x2 cd cs) cd cs) (Curry_System.d_C_system x2 cd cs) cd cs

d_C_execMain :: Curry_Linker.C_ReplState -> Curry_Linker.C_MainCompile -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_C_execMain x1 x2 x3 cd cs = let
     x4 = d_C__case_79 x1 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_ndMode x1 cd cs) cd cs
     x8 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString ".") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_outputSubdir x1 cd cs) cd cs) (Curry_Prelude.toCurryString "Main") cd cs) cd cs
     x9 = Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_profile x1 cd cs
     x10 = d_C__case_77 x9 cd cs
     x11 = d_C__case_76 x9 x4 x1 x10 (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_null (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rtsOpts x1 cd cs) cd cs) (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_null x4 cd cs) (Curry_Prelude.d_C_not x9 cd cs) cd cs) cd cs) cd cs
     x12 = Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x8 (Curry_Prelude.OP_Cons x11 (Curry_Prelude.OP_Cons (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rtsArgs x1 cd cs) Curry_Prelude.OP_List))) cd cs
      in (Curry_Prelude.d_OP_gt_gt_eq (Curry_Linker.d_C_getTimeCmd x1 (Curry_Prelude.toCurryString "Execution") x12 cd cs) (d_OP_execMain_dot_uscore_hash_lambda47 x3 x1) cd cs)

d_OP_execMain_dot_uscore_hash_lambda47 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_OP_execMain_dot_uscore_hash_lambda47 x1 x2 x3 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Linker.d_C_writeVerboseInfo x2 (Curry_Prelude.C_Int 1#)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Evaluating expression: ") (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x1 cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Linker.d_C_writeVerboseInfo x2 (Curry_Prelude.C_Int 3#)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Executing: ") x3 cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt_eq (Curry_System.d_C_system x3 cd cs) (d_OP_execMain_dot_uscore_hash_lambda47_dot_uscore_hash_lambda48 x2) cd cs) cd cs) cd cs

d_OP_execMain_dot_uscore_hash_lambda47_dot_uscore_hash_lambda48 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_OP_execMain_dot_uscore_hash_lambda47_dot_uscore_hash_lambda48 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 0#) cd cs)) (Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Evaluation terminated with non-zero status ") (Curry_Prelude.d_C_show x2 cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_return (Curry_Linker.d_C_setExitStatus x2 x1 cd cs) cd cs) cd cs

d_C_processCommand :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processCommand x1 x2 cd cs = let
     x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq) (Curry_Prelude.C_Char ' '#)) cd cs) x2 cd cs
     x4 = d_OP_processCommand_dot_uscore_hash_selFP12_hash_cmd x3 cd cs
     x5 = d_OP_processCommand_dot_uscore_hash_selFP13_hash_args x3 cd cs
     x6 = Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot (Curry_List.d_C_isPrefixOf (Curry_Prelude.d_C_map Curry_Char.d_C_toLower x4 cd cs)) Curry_Prelude.d_C_fst cd cs) (d_C_replCommands cd cs) cd cs
      in (d_C__case_75 x2 x6 x5 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs)

d_OP_processCommand_dot_uscore_hash_selFP12_hash_cmd :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processCommand_dot_uscore_hash_selFP12_hash_cmd x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processCommand_dot_uscore_hash_selFP12_hash_cmd l cd cs) (d_OP_processCommand_dot_uscore_hash_selFP12_hash_cmd r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processCommand_dot_uscore_hash_selFP12_hash_cmd z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processCommand_dot_uscore_hash_selFP12_hash_cmd e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processCommand._#selFP12#cmd" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processCommand._#selFP12#cmd" (showCons x1))

d_OP_processCommand_dot_uscore_hash_selFP13_hash_args :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processCommand_dot_uscore_hash_selFP13_hash_args x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processCommand_dot_uscore_hash_selFP13_hash_args l cd cs) (d_OP_processCommand_dot_uscore_hash_selFP13_hash_args r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processCommand_dot_uscore_hash_selFP13_hash_args z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processCommand_dot_uscore_hash_selFP13_hash_args e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processCommand._#selFP13#args" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processCommand._#selFP13#args" (showCons x1))

d_C_unsafeExec :: Curry_Linker.C_ReplState -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_unsafeExec x1 x2 cd cs = d_C__case_68 x1 x2 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_safeExec x1 cd cs) cd cs

nd_C_unsafeExec :: Curry_Linker.C_ReplState -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C_unsafeExec x1 x2 s cd cs = let
     s0 = s
      in (seq s0 (nd_C__case_68 x1 x2 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_safeExec x1 cd cs) s0 cd cs))

d_C_replCommands :: Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))
d_C_replCommands cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "?") (acceptCs id d_C_processHelp)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "add") (acceptCs id d_C_processAdd)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "browse") (acceptCs id d_C_processBrowse)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "cd") (acceptCs id d_C_processCd)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "edit") (acceptCs id d_C_processEdit)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "eval") (acceptCs id d_C_processEval)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "fork") (acceptCs id d_C_processFork)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "help") (acceptCs id d_C_processHelp)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "interface") (acceptCs id d_C_processInterface)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "load") (acceptCs id d_C_processLoad)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "programs") (acceptCs id d_C_processPrograms)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "reload") (acceptCs id d_C_processReload)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "quit") (acceptCs id d_C_processQuit)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "save") (acceptCs id d_C_processSave)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "set") (acceptCs id d_C_processSetOption)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "source") (acceptCs id d_C_processSource)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "show") (acceptCs id d_C_processShow)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "type") (acceptCs id d_C_processType)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "usedimports") (acceptCs id d_C_processUsedImports)) Curry_Prelude.OP_List))))))))))))))))))

nd_C_replCommands :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))))
nd_C_replCommands s cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "?") (wrapDX (wrapDX id) (acceptCs id d_C_processHelp))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "add") (wrapDX (wrapDX id) (acceptCs id d_C_processAdd))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "browse") (wrapDX (wrapDX id) (acceptCs id d_C_processBrowse))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "cd") (wrapDX (wrapDX id) (acceptCs id d_C_processCd))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "edit") (wrapDX (wrapDX id) (acceptCs id d_C_processEdit))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "eval") (wrapDX (wrapDX id) (acceptCs id d_C_processEval))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "fork") (wrapDX (wrapDX id) (acceptCs id d_C_processFork))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "help") (wrapDX (wrapDX id) (acceptCs id d_C_processHelp))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "interface") (wrapDX (wrapDX id) (acceptCs id d_C_processInterface))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "load") (wrapDX (wrapDX id) (acceptCs id d_C_processLoad))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "programs") (wrapDX (wrapDX id) (acceptCs id d_C_processPrograms))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "reload") (wrapDX (wrapDX id) (acceptCs id d_C_processReload))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "quit") (wrapDX (wrapDX id) (acceptCs id d_C_processQuit))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "save") (wrapDX (wrapDX id) (acceptCs id d_C_processSave))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "set") (wrapDX (wrapDX id) (acceptCs id d_C_processSetOption))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "source") (wrapDX (wrapDX id) (acceptCs id d_C_processSource))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "show") (wrapDX (wrapDX id) (acceptCs id d_C_processShow))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "type") (wrapDX (wrapDX id) (acceptCs id d_C_processType))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "usedimports") (wrapDX (wrapDX id) (acceptCs id d_C_processUsedImports))) Curry_Prelude.OP_List))))))))))))))))))

d_C_skipCommand :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_skipCommand x1 cd cs = Curry_Prelude.d_OP_gt_gt (d_C_writeErrorMsg x1 cd cs) (Curry_Prelude.d_C_return Curry_Prelude.C_Nothing cd cs) cd cs

d_C_processSysCall :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processSysCall x1 x2 cd cs = d_C__case_67 x2 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs

d_C_processQuit :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processQuit x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_quit x1 Curry_Prelude.C_True cd cs)) cd cs

d_C_processHelp :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processHelp x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (d_C_printHelpOnCommands cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_putStrLn (Curry_Prelude.toCurryString "... or type any <expression> to evaluate\n") cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) cd cs) cd cs

d_C_processLoad :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processLoad x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_terminateSourceProgGUIs x1 cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50 x2) cd cs

d_OP_processLoad_dot_uscore_hash_lambda50 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processLoad_dot_uscore_hash_lambda50 x1 x2 cd cs = let
     x3 = Curry_Distribution.d_C_stripCurrySuffix x1 cd cs
      in (d_C__case_65 x3 x2 (Curry_Prelude.d_C_null x3 cd cs) cd cs)

d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP15_hash_dirname :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP15_hash_dirname x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP15_hash_dirname l cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP15_hash_dirname r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP15_hash_dirname z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP15_hash_dirname e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processLoad._#lambda50._#selFP15#dirname" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processLoad._#lambda50._#selFP15#dirname" (showCons x1))

d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP16_hash_modname :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP16_hash_modname x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP16_hash_modname l cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP16_hash_modname r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP16_hash_modname z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP16_hash_modname e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processLoad._#lambda50._#selFP16#modname" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processLoad._#lambda50._#selFP16#modname" (showCons x1))

d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51 x1 x2 x3 cd cs = Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_return Curry_Prelude.C_Nothing cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52 x1 x2) x3 cd cs

d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52 x1 x2 x3 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Distribution.d_C_lookupModuleSourceInLoadPath x2 cd cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.d_OP_dollar d_C_skipCommand (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "source file of module ") (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString " not found") cd cs) cd cs) cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53 x2 x3)) cd cs

d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53 x1 x2 x3 cd cs = case x3 of
     (Curry_Prelude.OP_Tuple2 x4 x5) -> Curry_Prelude.d_OP_gt_gt_eq (d_C_readAndProcessSourceFileOptions x2 x5 cd cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_return Curry_Prelude.C_Nothing cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53_dot_uscore_hash_lambda54 x1)) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53 x1 x2 l cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53 x1 x2 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processLoad._#lambda50._#lambda51._#lambda52._#lambda53" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.processLoad._#lambda50._#lambda51._#lambda52._#lambda53" (showCons x3))

d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53_dot_uscore_hash_lambda54 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51_dot_uscore_hash_lambda52_dot_uscore_hash_lambda53_dot_uscore_hash_lambda54 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (d_C_compileCurryProgram x2 x1 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_addMods (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_mainMod x2 x1 cd cs) Curry_Prelude.OP_List cd cs)) cd cs) cd cs

d_C_processReload :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processReload x1 x2 cd cs = d_C__case_63 x1 x2 (Curry_Prelude.d_OP_eq_eq (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_preludeName x1 cd cs) cd cs) cd cs

d_C_processAdd :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processAdd x1 x2 cd cs = d_C__case_60 x2 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs

d_OP_processAdd_dot_insert_dot_331 :: Curry_Prelude.Curry t0 => t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_processAdd_dot_insert_dot_331 x1 x2 cd cs = case x2 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x3 x4) -> d_C__case_58 x3 x1 x4 x2 (Curry_Prelude.d_OP_lt x1 x3 cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_processAdd_dot_insert_dot_331 x1 l cd cs) (d_OP_processAdd_dot_insert_dot_331 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_processAdd_dot_insert_dot_331 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_processAdd_dot_insert_dot_331 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL.processAdd.insert.331" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.processAdd.insert.331" (showCons x2))

d_OP_processAdd_dot_add_dot_331 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_OP_processAdd_dot_add_dot_331 x1 x2 cd cs = let
     x3 = Curry_Distribution.d_C_stripCurrySuffix x2 cd cs
      in (d_C__case_55 x3 x1 (Curry_Prelude.d_C_apply (d_C_validModuleName cd cs) x3 cd cs) cd cs)

d_OP_processAdd_dot_add_dot_331_dot_uscore_hash_lambda55 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_OP_processAdd_dot_add_dot_331_dot_uscore_hash_lambda55 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar d_C_writeErrorMsg (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Source file of module '") (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "' not found") cd cs) cd cs) cd cs) (Curry_Prelude.d_C_return x2 cd cs) cd cs
     (Curry_Prelude.C_Just x4) -> Curry_Prelude.d_C_return (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_addMods x2 (d_OP_processAdd_dot_insert_dot_331 x1 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_addMods x2 cd cs) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_OP_processAdd_dot_add_dot_331_dot_uscore_hash_lambda55 x1 x2 l cd cs) (d_OP_processAdd_dot_add_dot_331_dot_uscore_hash_lambda55 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_OP_processAdd_dot_add_dot_331_dot_uscore_hash_lambda55 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_OP_processAdd_dot_add_dot_331_dot_uscore_hash_lambda55 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "REPL.processAdd.add.331._#lambda55" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.processAdd.add.331._#lambda55" (showCons x3))

d_C_validModuleName :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_validModuleName cd cs = Curry_Prelude.d_C_all d_OP_validModuleName_dot_uscore_hash_lambda57 cd cs

d_OP_validModuleName_dot_uscore_hash_lambda57 :: Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_validModuleName_dot_uscore_hash_lambda57 x1 cd cs = Curry_Prelude.d_OP_bar_bar (Curry_Char.d_C_isAlphaNum x1 cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_eq_eq x1 (Curry_Prelude.C_Char '_'#) cd cs) (Curry_Prelude.d_OP_eq_eq x1 (Curry_Prelude.C_Char '.'#) cd cs) cd cs) cd cs

d_C_processEval :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processEval x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_evalExpression x1 x2 cd cs) (Curry_Prelude.d_OP_dot Curry_Prelude.d_C_return (acceptCs id Curry_Prelude.C_Just) cd cs) cd cs

d_C_processType :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processType x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_showTypeOfGoal x1 x2 cd cs) (d_OP_processType_dot_uscore_hash_lambda58 x1) cd cs

d_OP_processType_dot_uscore_hash_lambda58 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processType_dot_uscore_hash_lambda58 x1 x2 cd cs = Curry_Prelude.d_C_return (d_C__case_54 x1 x2 cd cs) cd cs

d_C_processCd :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processCd x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_getAbsolutePath x2 cd cs) (d_OP_processCd_dot_uscore_hash_lambda59 x1) cd cs

d_OP_processCd_dot_uscore_hash_lambda59 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processCd_dot_uscore_hash_lambda59 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesDirectoryExist x2 cd cs) (d_OP_processCd_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x2 x1) cd cs

d_OP_processCd_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processCd_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Directory.d_C_setCurrentDirectory x1 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x2) cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar d_C_skipCommand (Curry_Prelude.toCurryString "directory does not exist") cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_OP_processCd_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1 x2 l cd cs) (d_OP_processCd_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_OP_processCd_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_OP_processCd_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.processCd._#lambda59._#lambda60" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.processCd._#lambda59._#lambda60" (showCons x3))

d_C_processPrograms :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processPrograms x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (d_C_printAllLoadPathPrograms x1 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) cd cs

d_C_processEdit :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processEdit x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getModuleName x1 x2 cd cs) (d_OP_processEdit_dot_uscore_hash_lambda61 x1) cd cs

d_OP_processEdit_dot_uscore_hash_lambda61 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processEdit_dot_uscore_hash_lambda61 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Files.d_C_lookupFileInPath (Curry_Prelude.d_C_apply (Curry_Names.d_C_moduleNameToPath cd cs) x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".curry") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".lcurry") Curry_Prelude.OP_List)) (Curry_Linker.d_C_loadPaths x1 cd cs) cd cs) (d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62 x1) cd cs

d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_System.d_C_getEnviron (Curry_Prelude.toCurryString "EDITOR") cd cs) (d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62_dot_uscore_hash_lambda63 x2 x1) cd cs

d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62_dot_uscore_hash_lambda63 :: Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62_dot_uscore_hash_lambda63 x1 x2 x3 cd cs = let
     x4 = Curry_RCFile.d_C_rcValue (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rcvars x2 cd cs) (Curry_Prelude.toCurryString "editcommand") cd cs
     x5 = d_C__case_52 x4 x3 (Curry_Prelude.d_C_null x4 cd cs) cd cs
      in (d_C__case_53 x4 x3 x1 x2 x5 (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_null x3 cd cs) (Curry_Prelude.d_C_null x4 cd cs) cd cs) cd cs)

d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62_dot_uscore_hash_lambda63_dot_uscore_hash_lambda64 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62_dot_uscore_hash_lambda63_dot_uscore_hash_lambda64 x1 x2 x3 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_System.d_C_system (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString "& ") cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x2) cd cs) cd cs

d_C_processSource :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processSource x1 x2 cd cs = let
     x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq) (Curry_Prelude.C_Char '.'#)) cd cs) x2 cd cs
     x4 = d_OP_processSource_dot_uscore_hash_selFP18_hash_mod x3 cd cs
     x5 = d_OP_processSource_dot_uscore_hash_selFP19_hash_dotfun x3 cd cs
      in (d_C__case_51 x2 x5 x4 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs)

d_OP_processSource_dot_uscore_hash_selFP18_hash_mod :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processSource_dot_uscore_hash_selFP18_hash_mod x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processSource_dot_uscore_hash_selFP18_hash_mod l cd cs) (d_OP_processSource_dot_uscore_hash_selFP18_hash_mod r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processSource_dot_uscore_hash_selFP18_hash_mod z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processSource_dot_uscore_hash_selFP18_hash_mod e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processSource._#selFP18#mod" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processSource._#selFP18#mod" (showCons x1))

d_OP_processSource_dot_uscore_hash_selFP19_hash_dotfun :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processSource_dot_uscore_hash_selFP19_hash_dotfun x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processSource_dot_uscore_hash_selFP19_hash_dotfun l cd cs) (d_OP_processSource_dot_uscore_hash_selFP19_hash_dotfun r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processSource_dot_uscore_hash_selFP19_hash_dotfun z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processSource_dot_uscore_hash_selFP19_hash_dotfun e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processSource._#selFP19#dotfun" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processSource._#selFP19#dotfun" (showCons x1))

d_OP_processSource_dot_uscore_hash_lambda65 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processSource_dot_uscore_hash_lambda65 x1 x2 x3 cd cs = d_C__case_48 x3 x1 x2 (Curry_Prelude.d_C_null x3 cd cs) cd cs

d_C_getModuleName :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getModuleName x1 x2 cd cs = d_C__case_47 x2 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs

d_OP_getModuleName_dot_uscore_hash_selFP21_hash_dirname :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_getModuleName_dot_uscore_hash_selFP21_hash_dirname x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_getModuleName_dot_uscore_hash_selFP21_hash_dirname l cd cs) (d_OP_getModuleName_dot_uscore_hash_selFP21_hash_dirname r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_getModuleName_dot_uscore_hash_selFP21_hash_dirname z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_getModuleName_dot_uscore_hash_selFP21_hash_dirname e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.getModuleName._#selFP21#dirname" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.getModuleName._#selFP21#dirname" (showCons x1))

d_OP_getModuleName_dot_uscore_hash_selFP22_hash_mname :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_getModuleName_dot_uscore_hash_selFP22_hash_mname x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_getModuleName_dot_uscore_hash_selFP22_hash_mname l cd cs) (d_OP_getModuleName_dot_uscore_hash_selFP22_hash_mname r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_getModuleName_dot_uscore_hash_selFP22_hash_mname z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_getModuleName_dot_uscore_hash_selFP22_hash_mname e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.getModuleName._#selFP22#mname" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.getModuleName._#selFP22#mname" (showCons x1))

d_C_processShow :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processShow x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getModuleName x1 x2 cd cs) (d_OP_processShow_dot_uscore_hash_lambda66 x1) cd cs

d_OP_processShow_dot_uscore_hash_lambda66 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processShow_dot_uscore_hash_lambda66 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Files.d_C_lookupFileInPath (Curry_Prelude.d_C_apply (Curry_Names.d_C_moduleNameToPath cd cs) x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".curry") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".lcurry") Curry_Prelude.OP_List)) (Curry_Linker.d_C_loadPaths x1 cd cs) cd cs) (d_OP_processShow_dot_uscore_hash_lambda66_dot_uscore_hash_lambda67 x1) cd cs

d_OP_processShow_dot_uscore_hash_lambda66_dot_uscore_hash_lambda67 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processShow_dot_uscore_hash_lambda66_dot_uscore_hash_lambda67 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_Nothing -> d_C_skipCommand (Curry_Prelude.toCurryString "source file not found") cd cs
     (Curry_Prelude.C_Just x3) -> let
          x4 = Curry_RCFile.d_C_rcValue (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rcvars x1 cd cs) (Curry_Prelude.toCurryString "showcommand") cd cs
           in (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar Curry_System.d_C_system (Curry_Prelude.d_OP_plus_plus (d_C__case_45 x4 (Curry_Prelude.d_C_null x4 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) x3) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_putStrLn Curry_Prelude.OP_List cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) cd cs) cd cs)
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_OP_processShow_dot_uscore_hash_lambda66_dot_uscore_hash_lambda67 x1 l cd cs) (d_OP_processShow_dot_uscore_hash_lambda66_dot_uscore_hash_lambda67 x1 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_OP_processShow_dot_uscore_hash_lambda66_dot_uscore_hash_lambda67 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_OP_processShow_dot_uscore_hash_lambda66_dot_uscore_hash_lambda67 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "REPL.processShow._#lambda66._#lambda67" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.processShow._#lambda66._#lambda67" (showCons x2))

d_C_processInterface :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processInterface x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getModuleName x1 x2 cd cs) (d_OP_processInterface_dot_uscore_hash_lambda69 x1) cd cs

d_OP_processInterface_dot_uscore_hash_lambda69 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processInterface_dot_uscore_hash_lambda69 x1 x2 cd cs = let
     x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "currytools") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "genint") cd cs) (Curry_Prelude.toCurryString "GenInt") cd cs) cd cs
      in (d_C_callTool x1 x3 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "-int ") x2 cd cs) cd cs)

d_C_processBrowse :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processBrowse x1 x2 cd cs = d_C__case_44 x2 x1 (Curry_Prelude.d_OP_dollar (Curry_Utils.d_C_notNull cd cs) (Curry_Distribution.d_C_stripCurrySuffix x2 cd cs) cd cs) cd cs

d_C_processUsedImports :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processUsedImports x1 x2 cd cs = let
     x3 = d_C__case_42 x2 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs
     x4 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "currytools") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "importcalls") cd cs) (Curry_Prelude.toCurryString "ImportCalls") cd cs) cd cs
      in (d_C_callTool x1 x4 x3 cd cs)

d_C_processSave :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processSave x1 x2 cd cs = d_C__case_41 x1 x2 (Curry_Prelude.d_OP_eq_eq (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_preludeName x1 cd cs) cd cs) cd cs

d_OP_processSave_dot_uscore_hash_lambda70 :: Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processSave_dot_uscore_hash_lambda70 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless (Curry_Prelude.d_OP_eq_eq x3 Curry_Linker.C_MainError cd cs)) (Curry_Prelude.d_OP_gt_gt (Curry_Directory.d_C_renameFile (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString ".") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_outputSubdir x2 cd cs) cd cs) (Curry_Prelude.toCurryString "Main") cd cs) cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x2 cd cs) cd cs) (Curry_Linker.d_C_writeVerboseInfo x2 (Curry_Prelude.C_Int 1#) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Executable saved in '") (Curry_Prelude.d_OP_plus_plus (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x2 cd cs) (Curry_Prelude.toCurryString "'") cd cs) cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (d_C_cleanMainGoalFile x2 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x2) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processSave_dot_uscore_hash_lambda70 l cd cs) (d_OP_processSave_dot_uscore_hash_lambda70 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processSave_dot_uscore_hash_lambda70 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processSave_dot_uscore_hash_lambda70 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processSave._#lambda70" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processSave._#lambda70" (showCons x1))

d_C_processFork :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processFork x1 x2 cd cs = d_C__case_38 x1 x2 (Curry_Prelude.d_OP_eq_eq (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_preludeName x1 cd cs) cd cs) cd cs

d_OP_processFork_dot_uscore_hash_lambda71 :: Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processFork_dot_uscore_hash_lambda71 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless (Curry_Prelude.d_OP_eq_eq x3 Curry_Linker.C_MainError cd cs)) (Curry_Prelude.d_OP_gt_gt_eq (Curry_System.d_C_getPID cd cs) (d_OP_processFork_dot_uscore_hash_lambda71_dot_uscore_hash_lambda72 x2) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (d_C_cleanMainGoalFile x2 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x2) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processFork_dot_uscore_hash_lambda71 l cd cs) (d_OP_processFork_dot_uscore_hash_lambda71 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processFork_dot_uscore_hash_lambda71 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processFork_dot_uscore_hash_lambda71 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processFork._#lambda71" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processFork._#lambda71" (showCons x1))

d_OP_processFork_dot_uscore_hash_lambda71_dot_uscore_hash_lambda72 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_processFork_dot_uscore_hash_lambda71_dot_uscore_hash_lambda72 x1 x2 cd cs = let
     x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString ".") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_outputSubdir x1 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "kics2fork") (Curry_Prelude.d_C_show x2 cd cs) cd cs) cd cs) cd cs
      in (Curry_Prelude.d_OP_gt_gt (Curry_Directory.d_C_renameFile (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString ".") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_outputSubdir x1 cd cs) cd cs) (Curry_Prelude.toCurryString "Main") cd cs) cd cs) x3 cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 3#) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Starting executable '") (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString "'...") cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_System.d_C_system (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "( ") (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " && rm -f ") (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ") ") (Curry_Prelude.toCurryString "> /dev/null 2> /dev/null &") cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_done cd cs) cd cs) cd cs) cd cs)

d_C_processSetOption :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processSetOption x1 x2 cd cs = let
     x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq) (Curry_Prelude.C_Char ' '#)) cd cs) x2 cd cs
     x4 = d_OP_processSetOption_dot_uscore_hash_selFP24_hash_opt x3 cd cs
     x5 = d_OP_processSetOption_dot_uscore_hash_selFP25_hash_args x3 cd cs
     x6 = Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot (Curry_List.d_C_isPrefixOf (Curry_Prelude.d_C_map Curry_Char.d_C_toLower x4 cd cs)) Curry_Prelude.d_C_fst cd cs) (d_C_availOptions cd cs) cd cs
      in (d_C__case_35 x2 x6 x5 x1 (Curry_Prelude.d_C_null (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x2 cd cs) cd cs) cd cs)

d_OP_processSetOption_dot_uscore_hash_selFP24_hash_opt :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processSetOption_dot_uscore_hash_selFP24_hash_opt x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processSetOption_dot_uscore_hash_selFP24_hash_opt l cd cs) (d_OP_processSetOption_dot_uscore_hash_selFP24_hash_opt r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processSetOption_dot_uscore_hash_selFP24_hash_opt z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processSetOption_dot_uscore_hash_selFP24_hash_opt e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processSetOption._#selFP24#opt" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processSetOption._#selFP24#opt" (showCons x1))

d_OP_processSetOption_dot_uscore_hash_selFP25_hash_args :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_processSetOption_dot_uscore_hash_selFP25_hash_args x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_processSetOption_dot_uscore_hash_selFP25_hash_args l cd cs) (d_OP_processSetOption_dot_uscore_hash_selFP25_hash_args r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_processSetOption_dot_uscore_hash_selFP25_hash_args z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_processSetOption_dot_uscore_hash_selFP25_hash_args e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.processSetOption._#selFP25#args" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.processSetOption._#selFP25#args" (showCons x1))

d_C_availOptions :: Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))
d_C_availOptions cd cs = Curry_Prelude.d_C_filter d_OP_availOptions_dot_installOpts_dot_426 (d_C_replOptions cd cs) cd cs

nd_C_availOptions :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))))
nd_C_availOptions s cd cs = let
     s2 = s
      in (seq s2 (let
          s1 = leftSupply s2
          s0 = rightSupply s2
           in (seq s1 (seq s0 (Curry_Prelude.nd_C_filter (wrapDX id d_OP_availOptions_dot_installOpts_dot_426) (nd_C_replOptions s0 cd cs) s1 cd cs)))))

d_OP_availOptions_dot_installOpts_dot_426 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_availOptions_dot_installOpts_dot_426 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_not (Curry_Installation.d_C_installGlobal cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_notElem x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "supply") Curry_Prelude.OP_List) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_availOptions_dot_installOpts_dot_426 l cd cs) (d_OP_availOptions_dot_installOpts_dot_426 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_availOptions_dot_installOpts_dot_426 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_availOptions_dot_installOpts_dot_426 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.availOptions.installOpts.426" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.availOptions.installOpts.426" (showCons x1))

d_C_replOptions :: Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))
d_C_replOptions cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "paths") (acceptCs id d_C_setOptionPath)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "bfs") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda74)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "dfs") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda75)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "prdfs") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda76)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "debugsearch") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda77)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "choices") (acceptCs id (d_C_setOptionNDMode (acceptCs id Curry_Linker.C_PrtChoices) (Curry_Prelude.C_Int 10#)))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "ids") (acceptCs id (d_C_setOptionNDMode (acceptCs id Curry_Linker.C_IDS) (Curry_Prelude.C_Int 100#)))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "parallel") (acceptCs id (d_C_setOptionNDMode (acceptCs id Curry_Linker.C_Par) (Curry_Prelude.C_Int 0#)))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "supply") (acceptCs id d_C_setOptionSupply)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v0") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda78)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v1") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda79)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v2") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda80)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v3") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda81)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v4") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda82)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "prompt") (acceptCs id d_C_setPrompt)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+interactive") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda83)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-interactive") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda84)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+first") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda85)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-first") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda86)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+optimize") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda87)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-optimize") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda88)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+bindings") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda89)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-bindings") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda90)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+time") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda91)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-time") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda92)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+trace") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda93)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-trace") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda94)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+profile") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda95)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-profile") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda96)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+ghci") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda97)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-ghci") (acceptCs id d_C_setNoGhci)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "safe") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda98)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "prelude") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda99)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "parser") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda100)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "cmp") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda101)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "ghc") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda102)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "rts") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda103)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "args") (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda104)) Curry_Prelude.OP_List)))))))))))))))))))))))))))))))))))))

nd_C_replOptions :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))))
nd_C_replOptions s cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "paths") (wrapDX (wrapDX id) (acceptCs id d_C_setOptionPath))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "bfs") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda74))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "dfs") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda75))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "prdfs") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda76))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "debugsearch") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda77))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "choices") (wrapDX (wrapNX id) (acceptCs id (nd_C_setOptionNDMode (wrapDX id (acceptCs id Curry_Linker.C_PrtChoices)) (Curry_Prelude.C_Int 10#))))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "ids") (wrapDX (wrapNX id) (acceptCs id (nd_C_setOptionNDMode (wrapDX id (acceptCs id Curry_Linker.C_IDS)) (Curry_Prelude.C_Int 100#))))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "parallel") (wrapDX (wrapNX id) (acceptCs id (nd_C_setOptionNDMode (wrapDX id (acceptCs id Curry_Linker.C_Par)) (Curry_Prelude.C_Int 0#))))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "supply") (wrapDX (wrapDX id) (acceptCs id d_C_setOptionSupply))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v0") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda78))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v1") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda79))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v2") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda80))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v3") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda81))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "v4") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda82))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "prompt") (wrapDX (wrapDX id) (acceptCs id d_C_setPrompt))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+interactive") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda83))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-interactive") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda84))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+first") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda85))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-first") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda86))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+optimize") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda87))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-optimize") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda88))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+bindings") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda89))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-bindings") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda90))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+time") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda91))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-time") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda92))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+trace") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda93))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-trace") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda94))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+profile") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda95))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-profile") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda96))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "+ghci") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda97))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "-ghci") (wrapDX (wrapDX id) (acceptCs id d_C_setNoGhci))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "safe") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda98))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "prelude") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda99))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "parser") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda100))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "cmp") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda101))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "ghc") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda102))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "rts") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda103))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "args") (wrapDX (wrapDX id) (acceptCs id d_OP_replOptions_dot_uscore_hash_lambda104))) Curry_Prelude.OP_List)))))))))))))))))))))))))))))))))))))

d_OP_replOptions_dot_uscore_hash_lambda74 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda74 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x1 Curry_Linker.C_BFS cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda75 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda75 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x1 Curry_Linker.C_DFS cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda76 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda76 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x1 Curry_Linker.C_PrDFS cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda77 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda77 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x1 Curry_Linker.C_DEBUG cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda78 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda78 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_verbose x1 (Curry_Prelude.C_Int 0#) cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda79 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda79 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_verbose x1 (Curry_Prelude.C_Int 1#) cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda80 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda80 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_verbose x1 (Curry_Prelude.C_Int 2#) cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda81 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda81 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_verbose x1 (Curry_Prelude.C_Int 3#) cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda82 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda82 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_verbose x1 (Curry_Prelude.C_Int 4#) cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda83 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda83 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_interactive x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda84 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda84 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_interactive x1 Curry_Prelude.C_False cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda85 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda85 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_firstSol x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda86 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda86 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_firstSol x1 Curry_Prelude.C_False cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda87 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda87 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_optim x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda88 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda88 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_optim x1 Curry_Prelude.C_False cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda89 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda89 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_showBindings x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda90 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda90 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_showBindings x1 Curry_Prelude.C_False cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda91 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda91 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_showTime x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda92 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda92 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_showTime x1 Curry_Prelude.C_False cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda93 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda93 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_traceFailure x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda94 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda94 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_traceFailure x1 Curry_Prelude.C_False cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda95 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda95 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_profile x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda96 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda96 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_profile x1 Curry_Prelude.C_False cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda97 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda97 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_useGhci x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda98 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda98 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_safeExec x1 Curry_Prelude.C_True cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda99 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda99 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_preludeName x1 x2 cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda100 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda100 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_parseOpts x1 x2 cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda101 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda101 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_cmpOpts x1 x2 cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda102 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda102 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ghcOpts x1 x2 cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda103 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda103 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_rtsOpts x1 x2 cd cs)) cd cs

d_OP_replOptions_dot_uscore_hash_lambda104 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_replOptions_dot_uscore_hash_lambda104 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_rtsArgs x1 x2 cd cs)) cd cs

d_C_setPrompt :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_setPrompt x1 x2 cd cs = let
     x3 = Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x2 cd cs
      in (d_C__case_30 x3 x1 (Curry_Prelude.d_C_null x3 cd cs) cd cs)

d_C_setNoGhci :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_setNoGhci x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_done cd cs) Curry_GhciComm.d_C_stopGhciComm (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_ghcicomm x1 cd cs) cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ghcicomm (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_useGhci x1 Curry_Prelude.C_False cd cs) Curry_Prelude.C_Nothing cd cs)) cd cs) cd cs

d_C_setOptionPath :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_setOptionPath x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C__case_23 x2 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs) (d_OP_setOptionPath_dot_uscore_hash_lambda107 x1) cd cs

d_OP_setOptionPath_dot_uscore_hash_lambda107 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_setOptionPath_dot_uscore_hash_lambda107 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_importPaths x1 x2 cd cs)) cd cs

d_C_setOptionNDMode :: (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Linker.C_NonDetMode) -> Curry_Prelude.C_Int -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_setOptionNDMode x1 x2 x3 x4 cd cs = d_C__case_22 x4 x1 x3 x2 (Curry_Prelude.d_C_null x4 cd cs) cd cs

nd_C_setOptionNDMode :: Func Curry_Prelude.C_Int Curry_Linker.C_NonDetMode -> Curry_Prelude.C_Int -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C_setOptionNDMode x1 x2 x3 x4 s cd cs = let
     s0 = s
      in (seq s0 (nd_C__case_22 x4 x1 x3 x2 (Curry_Prelude.d_C_null x4 cd cs) s0 cd cs))

d_C_setOptionSupply :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_setOptionSupply x1 x2 cd cs = let
     x3 = Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "integer") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "ghc") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "ioref") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "pureio") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "giants") Curry_Prelude.OP_List))))
      in (d_C__case_17 x3 x2 x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x2 cd cs) x3 cd cs) cd cs)

d_C_printOptions :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_printOptions x1 cd cs = Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_unlines (Curry_Prelude.d_C_filter (Curry_Utils.d_C_notNull cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Options for ':set' command:") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "path <paths>    - set additional search paths for imported modules") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "prdfs           - set search mode to primitive depth-first search") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "dfs             - set search mode to depth-first search") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "bfs             - set search mode to breadth-first search") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "ids [<n>]       - set search mode to iterative deepening (initial depth <n>)") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "parallel [<n>]  - set search mode to parallel search with <n> threads") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "choices [<n>]   - set search mode to print the choice structure as a tree") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "                  (up to level <n>)") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "debugsearch     - set search mode to print debugging information") (Curry_Prelude.OP_Cons (d_C_ifLocal (Curry_Prelude.toCurryString "supply <I>      - set idsupply implementation (ghc|giants|integer|ioref|pureio)") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "v<n>            - verbosity level") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "                    0: quiet (errors and warnings only)") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "                    1: frontend status messages (default)") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "                    2: kics2c status messages") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "                    3: ghc status messages") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "                    4: analysis information") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "prompt <prompt> - set the user prompt") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+/-interactive  - turn on/off interactive execution of main goal") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+/-first        - turn on/off printing only first solution") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+/-optimize     - turn on/off optimization") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+/-bindings     - show bindings of free variables in initial goal") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+/-time         - show compilation and execution time") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+/-trace        - trace failure in deterministic expression") (Curry_Prelude.OP_Cons (d_C_ifProfiling (Curry_Prelude.toCurryString "+/-profile      - compile with GHC's profiling capabilities") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+/-ghci         - use ghci instead of ghc to evaluate main expression") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "safe            - safe execution mode without I/O actions") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "prelude <name>  - name of the standard prelude") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "parser  <opts>  - additional options passed to parser (front end)") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "cmp     <opts>  - additional options passed to KiCS2 compiler") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "ghc     <opts>  - additional options passed to GHC") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "rts     <opts>  - run-time options for ghc (+RTS <opts> -RTS)") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "args    <args>  - run-time arguments passed to main program") (Curry_Prelude.OP_Cons (d_C_showCurrentOptions x1 cd cs) Curry_Prelude.OP_List)))))))))))))))))))))))))))))))))) cd cs) cd cs) cd cs

d_C_ifLocal :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_ifLocal x1 cd cs = d_C__case_15 x1 (Curry_Installation.d_C_installGlobal cd cs) cd cs

d_C_ifProfiling :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_ifProfiling x1 cd cs = d_C__case_14 x1 (Curry_Installation.d_C_withProfiling cd cs) cd cs

d_C_showCurrentOptions :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurrentOptions x1 cd cs = Curry_Prelude.d_OP_dollar (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString "\n")) (Curry_Prelude.d_C_filter (Curry_Utils.d_C_notNull cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "\nCurrent settings:") (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "import paths      : ") (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ":") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_importPaths x1 cd cs)) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "search mode       : ") (d_C__case_13 x1 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_ndMode x1 cd cs) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_dollar d_C_ifLocal (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "idsupply          : ") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_idSupply x1 cd cs) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "prelude           : ") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_preludeName x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "parser options    : ") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_parseOpts x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "compiler options  : ") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_cmpOpts x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "ghc options       : ") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_ghcOpts x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "run-time options  : ") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rtsOpts x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "run-time arguments: ") (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rtsArgs x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "verbosity         : ") (Curry_Prelude.d_C_show (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_verbose x1 cd cs) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "prompt            : ") (Curry_Prelude.d_C_show (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_prompt x1 cd cs) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_unwords (Curry_Prelude.d_C_filter (Curry_Utils.d_C_notNull cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_interactive x1 cd cs) cd cs) (Curry_Prelude.toCurryString "interactive") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_firstSol x1 cd cs) cd cs) (Curry_Prelude.toCurryString "first") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_optim x1 cd cs) cd cs) (Curry_Prelude.toCurryString "optimize") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_showBindings x1 cd cs) cd cs) (Curry_Prelude.toCurryString "bindings") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_showTime x1 cd cs) cd cs) (Curry_Prelude.toCurryString "time") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_traceFailure x1 cd cs) cd cs) (Curry_Prelude.toCurryString "trace") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_dollar d_C_ifProfiling (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_profile x1 cd cs) cd cs) (Curry_Prelude.toCurryString "profile") cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (d_OP_showCurrentOptions_dot_showOnOff_dot_531 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_useGhci x1 cd cs) cd cs) (Curry_Prelude.toCurryString "ghci") cd cs) Curry_Prelude.OP_List)))))))) cd cs) cd cs) Curry_Prelude.OP_List))))))))))))) cd cs) cd cs

d_OP_showCurrentOptions_dot_showOnOff_dot_531 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurrentOptions_dot_showOnOff_dot_531 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> Curry_Prelude.toCurryString "+"
     Curry_Prelude.C_False -> Curry_Prelude.toCurryString "-"
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_OP_showCurrentOptions_dot_showOnOff_dot_531 l cd cs) (d_OP_showCurrentOptions_dot_showOnOff_dot_531 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_OP_showCurrentOptions_dot_showOnOff_dot_531 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_OP_showCurrentOptions_dot_showOnOff_dot_531 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.showCurrentOptions.showOnOff.531" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.showCurrentOptions.showOnOff.531" (showCons x1))

d_C_printHelpOnCommands :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_printHelpOnCommands cd cs = Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_C_unlines (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Commands (can be abbreviated to a prefix if unique)") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":load <prog>       - load program '<prog>.[l]curry' as main module") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":add  <m1> .. <mn> - add modules '<m1>' to '<mn>' to currently loaded modules") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":reload            - recompile currently loaded modules") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":eval <expr>       - evaluate expression <expr>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":type <expr>       - show type of expression <expr>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":programs          - show names of all Curry programs available in load path") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":cd <dir>          - change current directory to <dir>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":edit              - load source of currently loaded module into editor") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":edit <m>          - load source of module <m> into editor") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":show              - show currently loaded source program") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":show <m>          - show source of module <m>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":source <f>        - show source of (visible!) function <f>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":source <m>.<f>    - show source of function <f> in module <m>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":browse            - browse program and its imported modules") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":interface         - show interface of currently loaded module") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":interface <m>     - show interface of module <m>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":usedimports       - show all used imported functions/constructors") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":set <option>      - set an option") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":set               - see help on options and current options") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":save              - save executable with main expression 'main'") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":save <expr>       - save executable with main expression <expr>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":fork <expr>       - fork new process evaluating <expr>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":help              - show this message") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":!<command>        - execute <command> in shell") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ":quit              - leave the system") Curry_Prelude.OP_List)))))))))))))))))))))))))) cd cs) cd cs

d_C_printAllLoadPathPrograms :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_printAllLoadPathPrograms x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapIO_ d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551 cd cs) (Curry_Linker.d_C_loadPaths x1 cd cs) cd cs

d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551 x1 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Curry programs in directory ") (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString ":") cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_getDirectoryContents x1 cd cs) d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110 cd cs) cd cs

d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110 x1 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_concat (Curry_Prelude.d_OP_dollar (Curry_Sort.d_C_mergeSort (acceptCs id Curry_Prelude.d_OP_lt_eq)) (Curry_Prelude.d_C_map d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111 x1 cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_putStrLn Curry_Prelude.OP_List cd cs) cd cs

d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111 x1 cd cs = let
     x2 = Curry_FilePath.d_C_splitExtension x1 cd cs
     x3 = d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP27_hash_base x2 cd cs
     x4 = d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP28_hash_sfx x2 cd cs
      in (d_C__case_12 x3 x4 x1 (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x4 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "curry") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "lcurry") Curry_Prelude.OP_List)) cd cs) (Curry_Prelude.d_C_apply (Curry_Utils.d_C_notNull cd cs) x3 cd cs) cd cs) cd cs)

d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP27_hash_base :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP27_hash_base x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP27_hash_base l cd cs) (d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP27_hash_base r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP27_hash_base z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP27_hash_base e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.printAllLoadPathPrograms.printDirPrograms.551._#lambda110._#lambda111._#selFP27#base" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.printAllLoadPathPrograms.printDirPrograms.551._#lambda110._#lambda111._#selFP27#base" (showCons x1))

d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP28_hash_sfx :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP28_hash_sfx x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP28_hash_sfx l cd cs) (d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP28_hash_sfx r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP28_hash_sfx z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_printAllLoadPathPrograms_dot_printDirPrograms_dot_551_dot_uscore_hash_lambda110_dot_uscore_hash_lambda111_dot_uscore_hash_selFP28_hash_sfx e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.printAllLoadPathPrograms.printDirPrograms.551._#lambda110._#lambda111._#selFP28#sfx" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.printAllLoadPathPrograms.printDirPrograms.551._#lambda110._#lambda111._#selFP28#sfx" (showCons x1))

d_C_showFunctionInModule :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_showFunctionInModule x1 x2 x3 cd cs = let
     x4 = Curry_Prelude.d_C_lookup x2 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_sourceguis x1 cd cs) cd cs
     x5 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "currytools") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "browser") cd cs) (Curry_Prelude.toCurryString "SourceProgGUI") cd cs) cd cs
     x6 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_kics2Home x1 cd cs) cd cs) x5 cd cs
      in (Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x6 cd cs) (d_OP_showFunctionInModule_dot_uscore_hash_lambda112 x3 x4 x2 x1 x6 x5) cd cs)

d_OP_showFunctionInModule_dot_updateFun_dot_559 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1,Curry_Prelude.Curry t2) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2)) -> t0 -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2))
d_OP_showFunctionInModule_dot_updateFun_dot_559 x1 x2 x3 cd cs = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x4 x5) -> d_C__case_11 x2 x3 x5 x4 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_showFunctionInModule_dot_updateFun_dot_559 l x2 x3 cd cs) (d_OP_showFunctionInModule_dot_updateFun_dot_559 r x2 x3 cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_showFunctionInModule_dot_updateFun_dot_559 z x2 x3 cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_showFunctionInModule_dot_updateFun_dot_559 e x2 x3 cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL.showFunctionInModule.updateFun.559" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL.showFunctionInModule.updateFun.559" (showCons x1))

d_OP_showFunctionInModule_dot_uscore_hash_lambda112 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_IO.C_Handle) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_showFunctionInModule_dot_uscore_hash_lambda112 x1 x2 x3 x4 x5 x6 x7 cd cs = d_C__case_8 x7 x1 x2 x4 x3 x5 x6 (Curry_Prelude.d_C_not x7 cd cs) cd cs

d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda113 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_IO.C_Handle)
d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda113 x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_sourceguis x3 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.OP_Tuple2 x1 x4)) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_sourceguis x3 cd cs)) cd cs) x4) cd cs

d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda114 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_IO.C_Handle)
d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda114 x1 x2 x3 x4 cd cs = case x4 of
     (Curry_Prelude.OP_Tuple2 x5 x6) -> Curry_Prelude.d_OP_gt_gt (Curry_IO.d_C_hPutStrLn x6 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) x5) cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_IO.d_C_hFlush x6 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_sourceguis x3 (d_OP_showFunctionInModule_dot_updateFun_dot_559 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_sourceguis x3 cd cs) x2 x1 cd cs) cd cs) x6) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda114 x1 x2 x3 l cd cs) (d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda114 x1 x2 x3 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda114 x1 x2 x3 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda114 x1 x2 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.showFunctionInModule._#lambda112._#lambda114" [(show x1),(show x2),(show x3),(show x4)] info)
     _ -> failCons cd (consFail "REPL.showFunctionInModule._#lambda112._#lambda114" (showCons x4))

d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda115 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda115 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_Prelude.d_OP_gt_gt (Curry_IO.d_C_hPutStrLn x4 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '+'#) x1) cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_IO.d_C_hFlush x4 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x3) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda115 x1 l cd cs) (d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda115 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda115 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda115 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.showFunctionInModule._#lambda112._#lambda115" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.showFunctionInModule._#lambda112._#lambda115" (showCons x2))

d_C_callTool :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_callTool x1 x2 x3 cd cs = let
     x4 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_kics2Home x1 cd cs) cd cs) x2 cd cs
      in (Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x4 cd cs) (d_OP_callTool_dot_uscore_hash_lambda116 x3 x2 x4 x1) cd cs)

d_OP_callTool_dot_uscore_hash_lambda116 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_callTool_dot_uscore_hash_lambda116 x1 x2 x3 x4 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_System.d_C_system (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) x1) cd cs) cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x4) cd cs) cd cs
     Curry_Prelude.C_False -> d_C_errorMissingTool x2 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_OP_callTool_dot_uscore_hash_lambda116 x1 x2 x3 x4 l cd cs) (d_OP_callTool_dot_uscore_hash_lambda116 x1 x2 x3 x4 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_OP_callTool_dot_uscore_hash_lambda116 x1 x2 x3 x4 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_OP_callTool_dot_uscore_hash_lambda116 x1 x2 x3 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.callTool._#lambda116" [(show x1),(show x2),(show x3),(show x4),(show x5)] info)
     _ -> failCons cd (consFail "REPL.callTool._#lambda116" (showCons x5))

d_C_errorMissingTool :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_errorMissingTool x1 cd cs = Curry_Prelude.d_OP_dollar d_C_skipCommand (Curry_Prelude.d_OP_plus_plus (Curry_Installation.d_C_installDir cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '/'#) (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " not found\n") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Possible solution: run \"cd ") (Curry_Prelude.d_OP_plus_plus (Curry_Installation.d_C_installDir cd cs) (Curry_Prelude.toCurryString " && make install\"") cd cs) cd cs) cd cs) cd cs)) cd cs) cd cs

d_C_readAndProcessSourceFileOptions :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_readAndProcessSourceFileOptions x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_readSourceFileOptions x2 cd cs) (d_OP_readAndProcessSourceFileOptions_dot_uscore_hash_lambda117 x1) cd cs

d_OP_readAndProcessSourceFileOptions_dot_uscore_hash_lambda117 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_readAndProcessSourceFileOptions_dot_uscore_hash_lambda117 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless (Curry_Prelude.d_C_null x2 cd cs)) (Curry_Prelude.d_OP_dollar (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 1#)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Source file options: ") (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString " | ") (Curry_Prelude.d_C_map Curry_Prelude.d_C_unwords x2 cd cs) cd cs) cd cs) cd cs) cd cs) (d_C_processSourceFileOptions x1 x2 cd cs) cd cs

d_C_processSourceFileOptions :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C_processSourceFileOptions x1 x2 cd cs = case x2 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs
     (Curry_Prelude.OP_Cons x3 x4) -> Curry_Prelude.d_OP_gt_gt_eq (d_C_processSetOption x1 (Curry_Prelude.d_C_unwords x3 cd cs) cd cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_return Curry_Prelude.C_Nothing cd cs) (d_OP_processSourceFileOptions_dot_uscore_hash_lambda118 x4)) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_processSourceFileOptions x1 l cd cs) (d_C_processSourceFileOptions x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_processSourceFileOptions x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_processSourceFileOptions x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL.processSourceFileOptions" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.processSourceFileOptions" (showCons x2))

d_OP_processSourceFileOptions_dot_uscore_hash_lambda118 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_OP_processSourceFileOptions_dot_uscore_hash_lambda118 x1 x2 cd cs = d_C_processSourceFileOptions x2 x1 cd cs

d_C_readSourceFileOptions :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_readSourceFileOptions x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_IO.d_C_openFile x1 Curry_IO.C_ReadMode cd cs) d_OP_readSourceFileOptions_dot_uscore_hash_lambda123 cd cs

d_OP_readSourceFileOptions_dot_isOptionComment_dot_591 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_readSourceFileOptions_dot_isOptionComment_dot_591 x1 cd cs = Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_take (Curry_Prelude.C_Int 3#) x1 cd cs) (Curry_Prelude.toCurryString "{-#") cd cs

d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 x1 cd cs = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x2 x3) -> d_C__case_7 x2 x3 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 l cd cs) (d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL.readSourceFileOptions.extractOptionString.591" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.readSourceFileOptions.extractOptionString.591" (showCons x1))

d_OP_readSourceFileOptions_dot_getOptions_dot_591 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_readSourceFileOptions_dot_getOptions_dot_591 x1 cd cs = let
     x2 = Curry_Prelude.d_C_words (d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int 3#) x1 cd cs) cd cs) cd cs
      in (d_C__case_4 x2 (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_null x2 cd cs) (Curry_Prelude.d_OP_slash_eq (Curry_Prelude.d_C_map Curry_Char.d_C_toLower (Curry_Prelude.d_C_head x2 cd cs) cd cs) (Curry_Prelude.toCurryString "kics2_option") cd cs) cd cs) cd cs)

d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591 :: Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591 x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_IO.d_C_hIsEOF x1 cd cs) (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120 x1) cd cs

d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614 x1 cd cs = Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem (Curry_Prelude.d_C_take (Curry_Prelude.C_Int 6#) x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "module") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "import") Curry_Prelude.OP_List)) cd cs) (let
     x2 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break Curry_Char.d_C_isSpace cd cs) x1 cd cs
     x3 = d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614_dot_uscore_hash_selFP30_hash_w x2 cd cs
      in (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply (Curry_Utils.d_C_notNull cd cs) x3 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all Curry_Char.d_C_isAlphaNum cd cs) x3 cd cs) cd cs)) cd cs

d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614_dot_uscore_hash_selFP30_hash_w :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614_dot_uscore_hash_selFP30_hash_w x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614_dot_uscore_hash_selFP30_hash_w l cd cs) (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614_dot_uscore_hash_selFP30_hash_w r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614_dot_uscore_hash_selFP30_hash_w z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614_dot_uscore_hash_selFP30_hash_w e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.readSourceFileOptions.readHeaderLines.591.isModuleStart.614._#selFP30#w" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.readSourceFileOptions.readHeaderLines.591.isModuleStart.614._#selFP30#w" (showCons x1))

d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120 :: Curry_IO.C_Handle -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return Curry_Prelude.OP_List cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt_eq (Curry_IO.d_C_hGetLine x1 cd cs) (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120_dot_uscore_hash_lambda121 x1) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120 x1 l cd cs) (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL.readSourceFileOptions.readHeaderLines.591._#lambda120" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL.readSourceFileOptions.readHeaderLines.591._#lambda120" (showCons x2))

d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120_dot_uscore_hash_lambda121 :: Curry_IO.C_Handle -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120_dot_uscore_hash_lambda121 x1 x2 cd cs = d_C__case_3 x2 x1 (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_isModuleStart_dot_614 x2 cd cs) cd cs

d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120_dot_uscore_hash_lambda121_dot_uscore_hash_lambda122 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120_dot_uscore_hash_lambda121_dot_uscore_hash_lambda122 x1 x2 cd cs = Curry_Prelude.d_C_return (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x1 cd cs) x2) cd cs

d_OP_readSourceFileOptions_dot_uscore_hash_lambda123 :: Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_readSourceFileOptions_dot_uscore_hash_lambda123 x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591 x1 cd cs) (d_OP_readSourceFileOptions_dot_uscore_hash_lambda123_dot_uscore_hash_lambda124 x1) cd cs

d_OP_readSourceFileOptions_dot_uscore_hash_lambda123_dot_uscore_hash_lambda124 :: Curry_IO.C_Handle -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_readSourceFileOptions_dot_uscore_hash_lambda123_dot_uscore_hash_lambda124 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt (Curry_IO.d_C_hClose x1 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.d_C_filter (Curry_Utils.d_C_notNull cd cs) (Curry_Prelude.d_C_map d_OP_readSourceFileOptions_dot_getOptions_dot_591 (Curry_Prelude.d_C_filter d_OP_readSourceFileOptions_dot_isOptionComment_dot_591 x2 cd cs) cd cs) cd cs) cd cs) cd cs

d_C_terminateSourceProgGUIs :: Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_C_terminateSourceProgGUIs x1 cd cs = let
     x2 = Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_sourceguis x1 cd cs
      in (d_C__case_2 x2 x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs)

d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda125 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_IO.C_Handle) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda125 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> d_C__case_0 x3 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda125 l cd cs) (d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda125 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda125 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda125 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL.terminateSourceProgGUIs._#lambda125" [(show x1)] info)
     _ -> failCons cd (consFail "REPL.terminateSourceProgGUIs._#lambda125" (showCons x1))

d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda126 :: Curry_Prelude.C_IOError -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda126 x1 cd cs = Curry_Prelude.d_C_done cd cs

d_C__case_0 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_0 x3 cd cs = case x3 of
     (Curry_Prelude.OP_Tuple2 x4 x5) -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_gt_gt (Curry_IO.d_C_hPutStrLn x5 (Curry_Prelude.toCurryString "q") cd cs) (Curry_IO.d_C_hFlush x5 cd cs) cd cs) (Curry_IO.d_C_hClose x5 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_0 l cd cs) (d_C__case_0 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_0 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_0 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_0" [(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_0" (showCons x3))

d_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_IO.C_Handle)) -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_C__case_2 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return x1 cd cs
     Curry_Prelude.C_False -> d_C__case_1 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_2 x2 x1 l cd cs) (d_C__case_2 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_2 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_2 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_2" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_2" (showCons x3))

d_C__case_1 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_IO.C_Handle)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_C__case_1 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 1#) (Curry_Prelude.toCurryString "Terminating source program GUIs...") cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_catch (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapIO_ d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda125 cd cs) x2 cd cs) d_OP_terminateSourceProgGUIs_dot_uscore_hash_lambda126 cd cs) (Curry_Prelude.d_C_return (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_sourceguis x1 Curry_Prelude.OP_List cd cs) cd cs) cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_1 x1 x2 l cd cs) (d_C__case_1 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_1 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_1 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_1" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_1" (showCons x3))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_IO.C_Handle -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_3 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return Curry_Prelude.OP_List cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt_eq (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591 x1 cd cs) (d_OP_readSourceFileOptions_dot_readHeaderLines_dot_591_dot_uscore_hash_lambda120_dot_uscore_hash_lambda121_dot_uscore_hash_lambda122 x2) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_3 x2 x1 l cd cs) (d_C__case_3 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_3 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_3 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_3" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_3" (showCons x3))

d_C__case_4 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_4 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.d_C_tail x2 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_4 x2 l cd cs) (d_C__case_4 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_4 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_4 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_4" [(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_4" (showCons x3))

d_C__case_7 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_7 x2 x3 cd cs = case x3 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x4 x5) -> d_C__case_6 x3 x2 x5 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_7 x2 l cd cs) (d_C__case_7 x2 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_7 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_7 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_7" [(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_7" (showCons x3))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x3 x2 x5 cd cs = case x5 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x6 x7) -> d_C__case_5 x3 x2 (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.OP_Cons x2 (Curry_Prelude.d_C_take (Curry_Prelude.C_Int 2#) x3 cd cs)) (Curry_Prelude.toCurryString "#-}") cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_6 x3 x2 l cd cs) (d_C__case_6 x3 x2 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_6 x3 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_6 x3 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_6" [(show x3),(show x2),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_6" (showCons x5))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_5 x3 x2 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x2 (d_OP_readSourceFileOptions_dot_extractOptionString_dot_591 x3 cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_5 x3 x2 l cd cs) (d_C__case_5 x3 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_5 x3 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_5 x3 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_5" [(show x3),(show x2),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_5" (showCons x4))

d_C__case_8 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_IO.C_Handle) -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_8 x7 x1 x2 x4 x3 x5 x6 x8 cd cs = case x8 of
     Curry_Prelude.C_True -> d_C_errorMissingTool x6 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_maybe (Curry_Prelude.d_OP_gt_gt_eq (Curry_IOExts.d_C_connectToCommand (Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ") x3 cd cs) cd cs) cd cs) (d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda113 x1 x3 x4) cd cs) (d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda114 x1 x3 x4) x2 cd cs) (d_OP_showFunctionInModule_dot_uscore_hash_lambda112_dot_uscore_hash_lambda115 x1) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_8 x7 x1 x2 x4 x3 x5 x6 l cd cs) (d_C__case_8 x7 x1 x2 x4 x3 x5 x6 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_8 x7 x1 x2 x4 x3 x5 x6 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_8 x7 x1 x2 x4 x3 x5 x6 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_8" [(show x7),(show x1),(show x2),(show x4),(show x3),(show x5),(show x6),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_8" (showCons x8))

d_C__case_11 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1,Curry_Prelude.Curry t2) => t0 -> t1 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2)) -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2))
d_C__case_11 x2 x3 x5 x4 cd cs = case x4 of
     (Curry_Prelude.OP_Tuple2 x6 x7) -> d_C__case_10 x2 x6 x3 x5 x7 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_11 x2 x3 x5 l cd cs) (d_C__case_11 x2 x3 x5 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_11 x2 x3 x5 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_11 x2 x3 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_11" [(show x2),(show x3),(show x5),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_11" (showCons x4))

d_C__case_10 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1,Curry_Prelude.Curry t2) => t0 -> t0 -> t1 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2)) -> Curry_Prelude.OP_Tuple2 t1 t2 -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2))
d_C__case_10 x2 x6 x3 x5 x7 cd cs = case x7 of
     (Curry_Prelude.OP_Tuple2 x8 x9) -> d_C__case_9 x2 x6 x3 x5 x9 x8 (Curry_Prelude.d_OP_eq_eq x6 x2 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_10 x2 x6 x3 x5 l cd cs) (d_C__case_10 x2 x6 x3 x5 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_10 x2 x6 x3 x5 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_10 x2 x6 x3 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_10" [(show x2),(show x6),(show x3),(show x5),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_10" (showCons x7))

d_C__case_9 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1,Curry_Prelude.Curry t2) => t0 -> t0 -> t1 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2)) -> t2 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1 t2))
d_C__case_9 x2 x6 x3 x5 x9 x8 x10 cd cs = case x10 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6 (Curry_Prelude.OP_Tuple2 x3 x9)) x5
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6 (Curry_Prelude.OP_Tuple2 x8 x9)) (d_OP_showFunctionInModule_dot_updateFun_dot_559 x5 x2 x3 cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_9 x2 x6 x3 x5 x9 x8 l cd cs) (d_C__case_9 x2 x6 x3 x5 x9 x8 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_9 x2 x6 x3 x5 x9 x8 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_9 x2 x6 x3 x5 x9 x8 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_9" [(show x2),(show x6),(show x3),(show x5),(show x9),(show x8),(show x10)] info)
     _ -> failCons cd (consFail "REPL._case_9" (showCons x10))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_12 x3 x4 x1 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString " ") cd cs
     Curry_Prelude.C_False -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_12 x3 x4 x1 l cd cs) (d_C__case_12 x3 x4 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_12 x3 x4 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_12 x3 x4 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_12" [(show x3),(show x4),(show x1),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_12" (showCons x5))

d_C__case_13 :: Curry_Linker.C_ReplState -> Curry_Linker.C_NonDetMode -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_13 x1 x5 cd cs = case x5 of
     Curry_Linker.C_PrDFS -> Curry_Prelude.toCurryString "primitive non-monadic depth-first search"
     Curry_Linker.C_DEBUG -> Curry_Prelude.toCurryString "debugging information for search"
     (Curry_Linker.C_PrtChoices x2) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "show choice tree structure up to level ") (Curry_Prelude.d_C_show x2 cd cs) cd cs
     Curry_Linker.C_DFS -> Curry_Prelude.toCurryString "depth-first search"
     Curry_Linker.C_BFS -> Curry_Prelude.toCurryString "breadth-first search"
     (Curry_Linker.C_IDS x3) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "iterative deepening (initial depth: ") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x3 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
     (Curry_Linker.C_Par x4) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "parallel search with ") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x4 cd cs) (Curry_Prelude.toCurryString " threads") cd cs) cd cs
     (Curry_Linker.Choice_C_NonDetMode d i l r) -> narrow d i (d_C__case_13 x1 l cd cs) (d_C__case_13 x1 r cd cs)
     (Curry_Linker.Choices_C_NonDetMode d i xs) -> narrows cs d i (\z -> d_C__case_13 x1 z cd cs) xs
     (Curry_Linker.Guard_C_NonDetMode d c e) -> guardCons d c ((d_C__case_13 x1 e cd) $! (addCs c cs))
     (Curry_Linker.Fail_C_NonDetMode d info) -> failCons d (traceFail "REPL._case_13" [(show x1),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_13" (showCons x5))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_14 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> x1
     Curry_Prelude.C_False -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_14 x1 l cd cs) (d_C__case_14 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_14 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_14 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_14" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_14" (showCons x2))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_15 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> x1
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_15 x1 l cd cs) (d_C__case_15 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_15 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_15 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_15" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_15" (showCons x2))

d_C__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_17 x3 x2 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_idSupply x1 x2 cd cs)) cd cs
     Curry_Prelude.C_False -> d_C__case_16 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_17 x3 x2 x1 l cd cs) (d_C__case_17 x3 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_17 x3 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_17 x3 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_17" [(show x3),(show x2),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_17" (showCons x4))

d_C__case_16 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_16 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "unknown identifier supply") cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_16 l cd cs) (d_C__case_16 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_16 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_16 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_16" [(show x1)] info)
     _ -> failCons cd (consFail "REPL._case_16" (showCons x1))

d_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Linker.C_NonDetMode) -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_22 x4 x1 x3 x2 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x3 (Curry_Prelude.d_C_apply x1 x2 cd cs) cd cs)) cd cs
     Curry_Prelude.C_False -> d_C__case_21 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_22 x4 x1 x3 x2 l cd cs) (d_C__case_22 x4 x1 x3 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_22 x4 x1 x3 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_22 x4 x1 x3 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_22" [(show x4),(show x1),(show x3),(show x2),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_22" (showCons x5))

nd_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int Curry_Linker.C_NonDetMode -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_22 x4 x1 x3 x2 x5 s cd cs = case x5 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x3 (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs) cd cs)) cd cs))
     Curry_Prelude.C_False -> let
          s0 = s
           in (seq s0 (nd_C__case_21 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs))
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_22 x4 x1 x3 x2 l s cd cs) (nd_C__case_22 x4 x1 x3 x2 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_22 x4 x1 x3 x2 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_22 x4 x1 x3 x2 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_22" [(show x4),(show x1),(show x3),(show x2),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_22" (showCons x5))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Linker.C_NonDetMode) -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_21 x4 x1 x3 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> d_C__case_20 x4 x1 x3 (Curry_ReadNumeric.d_C_readNat x4 cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_21 x4 x1 x3 l cd cs) (d_C__case_21 x4 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_21 x4 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_21 x4 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_21" [(show x4),(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_21" (showCons x5))

nd_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int Curry_Linker.C_NonDetMode -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_21 x4 x1 x3 x5 s cd cs = case x5 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (nd_C__case_20 x4 x1 x3 (Curry_ReadNumeric.d_C_readNat x4 cd cs) s0 cd cs))
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_21 x4 x1 x3 l s cd cs) (nd_C__case_21 x4 x1 x3 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_21 x4 x1 x3 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_21 x4 x1 x3 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_21" [(show x4),(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_21" (showCons x5))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Linker.C_NonDetMode) -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_20 x4 x1 x3 x6 cd cs = case x6 of
     Curry_Prelude.C_Nothing -> d_C_skipCommand (Curry_Prelude.toCurryString "illegal number") cd cs
     (Curry_Prelude.C_Just x5) -> d_C__case_19 x1 x3 x5 cd cs
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C__case_20 x4 x1 x3 l cd cs) (d_C__case_20 x4 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C__case_20 x4 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C__case_20 x4 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "REPL._case_20" [(show x4),(show x1),(show x3),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_20" (showCons x6))

nd_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int Curry_Linker.C_NonDetMode -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_20 x4 x1 x3 x6 s cd cs = case x6 of
     Curry_Prelude.C_Nothing -> d_C_skipCommand (Curry_Prelude.toCurryString "illegal number") cd cs
     (Curry_Prelude.C_Just x5) -> let
          s0 = s
           in (seq s0 (nd_C__case_19 x1 x3 x5 s0 cd cs))
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (nd_C__case_20 x4 x1 x3 l s cd cs) (nd_C__case_20 x4 x1 x3 r s cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> nd_C__case_20 x4 x1 x3 z s cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((nd_C__case_20 x4 x1 x3 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "REPL._case_20" [(show x4),(show x1),(show x3),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_20" (showCons x6))

d_C__case_19 :: (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Linker.C_NonDetMode) -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_19 x1 x3 x5 cd cs = case x5 of
     (Curry_Prelude.OP_Tuple2 x6 x7) -> d_C__case_18 x7 x6 x1 x3 (Curry_Prelude.d_C_null (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x7 cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_19 x1 x3 l cd cs) (d_C__case_19 x1 x3 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_19 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_19 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_19" [(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_19" (showCons x5))

nd_C__case_19 :: Func Curry_Prelude.C_Int Curry_Linker.C_NonDetMode -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_19 x1 x3 x5 s cd cs = case x5 of
     (Curry_Prelude.OP_Tuple2 x6 x7) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (nd_C__case_18 x7 x6 x1 x3 (Curry_Prelude.d_C_null (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Utils.d_C_strip cd cs)) x7 s0 cd cs) cd cs) s1 cd cs)))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_C__case_19 x1 x3 l s cd cs) (nd_C__case_19 x1 x3 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_C__case_19 x1 x3 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_C__case_19 x1 x3 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_19" [(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_19" (showCons x5))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Linker.C_NonDetMode) -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_18 x7 x6 x1 x3 x8 cd cs = case x8 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x3 (Curry_Prelude.d_C_apply x1 x6 cd cs) cd cs)) cd cs
     Curry_Prelude.C_False -> d_C_skipCommand (Curry_Prelude.toCurryString "illegal number") cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_18 x7 x6 x1 x3 l cd cs) (d_C__case_18 x7 x6 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_18 x7 x6 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_18 x7 x6 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_18" [(show x7),(show x6),(show x1),(show x3),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_18" (showCons x8))

nd_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Func Curry_Prelude.C_Int Curry_Linker.C_NonDetMode -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_18 x7 x6 x1 x3 x8 s cd cs = case x8 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_ndMode x3 (Curry_Prelude.nd_C_apply x1 x6 s0 cd cs) cd cs)) cd cs))
     Curry_Prelude.C_False -> d_C_skipCommand (Curry_Prelude.toCurryString "illegal number") cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_18 x7 x6 x1 x3 l s cd cs) (nd_C__case_18 x7 x6 x1 x3 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_18 x7 x6 x1 x3 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_18 x7 x6 x1 x3 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_18" [(show x7),(show x6),(show x1),(show x3),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_18" (showCons x8))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_23 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_defaultImportPaths x1 cd cs
     Curry_Prelude.C_False -> d_C_defaultImportPathsWith x1 x2 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_23 x2 x1 l cd cs) (d_C__case_23 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_23 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_23 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_23" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_23" (showCons x3))

d_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_30 x3 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "no prompt specified") cd cs
     Curry_Prelude.C_False -> d_C__case_29 x3 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_30 x3 x1 l cd cs) (d_C__case_30 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_30 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_30 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_30" [(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_30" (showCons x4))

d_C__case_29 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_29 x3 x1 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> let
          x4 = Curry_Prelude.d_C_head x3 cd cs
           in (d_C__case_28 x4 x3 x1 (Curry_Prelude.d_OP_eq_eq x4 (Curry_Prelude.C_Char '"'#) cd cs) cd cs)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_29 x3 x1 l cd cs) (d_C__case_29 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_29 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_29 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_29" [(show x3),(show x1),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_29" (showCons x5))

d_C__case_28 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_28 x4 x3 x1 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> d_C__case_27 x3 x1 (Curry_ReadShowTerm.d_C_readsTerm x3 cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_prompt x1 x3 cd cs)) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_28 x4 x3 x1 l cd cs) (d_C__case_28 x4 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_28 x4 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_28 x4 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_28" [(show x4),(show x3),(show x1),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_28" (showCons x5))

d_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_27 x3 x1 x7 cd cs = case x7 of
     (Curry_Prelude.OP_Cons x5 x6) -> d_C__case_26 x6 x1 x5 cd cs
     Curry_Prelude.OP_List -> d_C_skipCommand (Curry_Prelude.toCurryString "could not parse prompt") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_27 x3 x1 l cd cs) (d_C__case_27 x3 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_27 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_27 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_27" [(show x3),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_27" (showCons x7))

d_C__case_26 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_26 x6 x1 x5 cd cs = case x5 of
     (Curry_Prelude.OP_Tuple2 x7 x8) -> d_C__case_25 x6 x7 x1 x8 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_26 x6 x1 l cd cs) (d_C__case_26 x6 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_26 x6 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_26 x6 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_26" [(show x6),(show x1),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_26" (showCons x5))

d_C__case_25 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_25 x6 x7 x1 x8 cd cs = case x8 of
     Curry_Prelude.OP_List -> d_C__case_24 x7 x1 x6 cd cs
     (Curry_Prelude.OP_Cons x11 x12) -> d_C_skipCommand (Curry_Prelude.toCurryString "could not parse prompt") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_25 x6 x7 x1 l cd cs) (d_C__case_25 x6 x7 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_25 x6 x7 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_25 x6 x7 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_25" [(show x6),(show x7),(show x1),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_25" (showCons x8))

d_C__case_24 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_24 x7 x1 x6 cd cs = case x6 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just (Curry_Linker.d_OP_uscore_hash_updR_at_ReplState_dot_prompt x1 x7 cd cs)) cd cs
     (Curry_Prelude.OP_Cons x9 x10) -> d_C_skipCommand (Curry_Prelude.toCurryString "could not parse prompt") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_24 x7 x1 l cd cs) (d_C__case_24 x7 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_24 x7 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_24 x7 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_24" [(show x7),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_24" (showCons x6))

d_C__case_35 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_35 x2 x6 x5 x1 x7 cd cs = case x7 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (d_C_printOptions x1 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_34 x6 x2 x5 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_35 x2 x6 x5 x1 l cd cs) (d_C__case_35 x2 x6 x5 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_35 x2 x6 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_35 x2 x6 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_35" [(show x2),(show x6),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_35" (showCons x7))

nd_C__case_35 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_35 x2 x6 x5 x1 x7 s cd cs = case x7 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_gt_gt (d_C_printOptions x1 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) s0 cd cs))
     Curry_Prelude.C_False -> let
          s0 = s
           in (seq s0 (nd_C__case_34 x6 x2 x5 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs))
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_35 x2 x6 x5 x1 l s cd cs) (nd_C__case_35 x2 x6 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_35 x2 x6 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_35 x2 x6 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_35" [(show x2),(show x6),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_35" (showCons x7))

d_C__case_34 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_34 x6 x2 x5 x1 x7 cd cs = case x7 of
     Curry_Prelude.C_True -> d_C__case_33 x2 x5 x1 x6 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_34 x6 x2 x5 x1 l cd cs) (d_C__case_34 x6 x2 x5 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_34 x6 x2 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_34 x6 x2 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_34" [(show x6),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_34" (showCons x7))

nd_C__case_34 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_34 x6 x2 x5 x1 x7 s cd cs = case x7 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (nd_C__case_33 x2 x5 x1 x6 s0 cd cs))
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_34 x6 x2 x5 x1 l s cd cs) (nd_C__case_34 x6 x2 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_34 x6 x2 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_34 x6 x2 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_34" [(show x6),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_34" (showCons x7))

d_C__case_33 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_33 x2 x5 x1 x6 cd cs = case x6 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar d_C_skipCommand (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "unknown option: '") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) cd cs
     (Curry_Prelude.OP_Cons x7 x8) -> d_C__case_32 x8 x2 x5 x1 x7 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_33 x2 x5 x1 l cd cs) (d_C__case_33 x2 x5 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_33 x2 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_33 x2 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_33" [(show x2),(show x5),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_33" (showCons x6))

nd_C__case_33 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_33 x2 x5 x1 x6 s cd cs = case x6 of
     Curry_Prelude.OP_List -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_dollar (wrapDX id d_C_skipCommand) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "unknown option: '") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) s0 cd cs))
     (Curry_Prelude.OP_Cons x7 x8) -> let
          s0 = s
           in (seq s0 (nd_C__case_32 x8 x2 x5 x1 x7 s0 cd cs))
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (nd_C__case_33 x2 x5 x1 l s cd cs) (nd_C__case_33 x2 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> nd_C__case_33 x2 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((nd_C__case_33 x2 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_33" [(show x2),(show x5),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_33" (showCons x6))

d_C__case_32 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_32 x8 x2 x5 x1 x7 cd cs = case x7 of
     (Curry_Prelude.OP_Tuple2 x9 x10) -> d_C__case_31 x2 x5 x1 x10 x8 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_32 x8 x2 x5 x1 l cd cs) (d_C__case_32 x8 x2 x5 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_32 x8 x2 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_32 x8 x2 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_32" [(show x8),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_32" (showCons x7))

nd_C__case_32 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_32 x8 x2 x5 x1 x7 s cd cs = case x7 of
     (Curry_Prelude.OP_Tuple2 x9 x10) -> let
          s0 = s
           in (seq s0 (nd_C__case_31 x2 x5 x1 x10 x8 s0 cd cs))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_C__case_32 x8 x2 x5 x1 l s cd cs) (nd_C__case_32 x8 x2 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_C__case_32 x8 x2 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_C__case_32 x8 x2 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_32" [(show x8),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_32" (showCons x7))

d_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_31 x2 x5 x1 x10 x8 cd cs = case x8 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x10 x1 cd cs) (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x5 cd cs) cd cs
     (Curry_Prelude.OP_Cons x11 x12) -> Curry_Prelude.d_OP_dollar d_C_skipCommand (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "ambiguous option: ':") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_31 x2 x5 x1 x10 l cd cs) (d_C__case_31 x2 x5 x1 x10 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_31 x2 x5 x1 x10 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_31 x2 x5 x1 x10 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_31" [(show x2),(show x5),(show x1),(show x10),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_31" (showCons x8))

nd_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_31 x2 x5 x1 x10 x8 s cd cs = case x8 of
     Curry_Prelude.OP_List -> let
          s3 = s
           in (seq s3 (let
               s2 = leftSupply s3
               s4 = rightSupply s3
               s0 = leftSupply s4
               s1 = rightSupply s4
                in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x10 x1 s0 cd cs) (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Utils.d_C_strip cd cs)) x5 s1 cd cs) s2 cd cs)))))))
     (Curry_Prelude.OP_Cons x11 x12) -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_dollar (wrapDX id d_C_skipCommand) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "ambiguous option: ':") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) s0 cd cs))
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (nd_C__case_31 x2 x5 x1 x10 l s cd cs) (nd_C__case_31 x2 x5 x1 x10 r s cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> nd_C__case_31 x2 x5 x1 x10 z s cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((nd_C__case_31 x2 x5 x1 x10 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_31" [(show x2),(show x5),(show x1),(show x10),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_31" (showCons x8))

d_C__case_38 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_38 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "no program loaded") cd cs
     Curry_Prelude.C_False -> d_C__case_37 x2 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_38 x1 x2 l cd cs) (d_C__case_38 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_38 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_38 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_38" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_38" (showCons x3))

d_C__case_37 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_37 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_compileProgramWithGoal x1 Curry_Prelude.C_True (d_C__case_36 x2 (Curry_Prelude.d_C_null x2 cd cs) cd cs) cd cs) d_OP_processFork_dot_uscore_hash_lambda71 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_37 x2 x1 l cd cs) (d_C__case_37 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_37 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_37 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_37" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_37" (showCons x3))

d_C__case_36 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_36 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.toCurryString "main"
     Curry_Prelude.C_False -> x2
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_36 x2 l cd cs) (d_C__case_36 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_36 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_36 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_36" [(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_36" (showCons x3))

d_C__case_41 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_41 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "no program loaded") cd cs
     Curry_Prelude.C_False -> d_C__case_40 x2 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_41 x1 x2 l cd cs) (d_C__case_41 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_41 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_41 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_41" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_41" (showCons x3))

d_C__case_40 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_40 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_compileProgramWithGoal x1 Curry_Prelude.C_True (d_C__case_39 x2 (Curry_Prelude.d_C_null x2 cd cs) cd cs) cd cs) d_OP_processSave_dot_uscore_hash_lambda70 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_40 x2 x1 l cd cs) (d_C__case_40 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_40 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_40 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_40" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_40" (showCons x3))

d_C__case_39 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_39 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.toCurryString "main"
     Curry_Prelude.C_False -> x2
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_39 x2 l cd cs) (d_C__case_39 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_39 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_39 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_39" [(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_39" (showCons x3))

d_C__case_42 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_42 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs
     Curry_Prelude.C_False -> Curry_Distribution.d_C_stripCurrySuffix x2 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_42 x2 x1 l cd cs) (d_C__case_42 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_42 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_42 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_42" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_42" (showCons x3))

d_C__case_44 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_44 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "superfluous argument") cd cs
     Curry_Prelude.C_False -> d_C__case_43 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_44 x2 x1 l cd cs) (d_C__case_44 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_44 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_44 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_44" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_44" (showCons x3))

d_C__case_43 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_43 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> let
          x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "currytools") cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString "browser") cd cs) (Curry_Prelude.toCurryString "BrowserGUI") cd cs) cd cs
           in (d_C_callTool x1 x3 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) cd cs)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_43 x1 l cd cs) (d_C__case_43 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_43 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_43 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_43" [(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_43" (showCons x4))

d_C__case_45 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_45 x4 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.toCurryString "cat"
     Curry_Prelude.C_False -> x4
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_45 x4 l cd cs) (d_C__case_45 x4 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_45 x4 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_45 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_45" [(show x4),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_45" (showCons x5))

d_C__case_47 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_47 x2 x1 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) cd cs
     Curry_Prelude.C_False -> let
          x3 = Curry_FilePath.d_C_splitFileName (Curry_Distribution.d_C_stripCurrySuffix x2 cd cs) cd cs
          x4 = d_OP_getModuleName_dot_uscore_hash_selFP21_hash_dirname x3 cd cs
          x5 = d_OP_getModuleName_dot_uscore_hash_selFP22_hash_mname x3 cd cs
           in (d_C__case_46 x4 x2 x5 (Curry_Prelude.d_OP_eq_eq x4 (Curry_Prelude.toCurryString "./") cd cs) cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_47 x2 x1 l cd cs) (d_C__case_47 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_47 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_47 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_47" [(show x2),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_47" (showCons x6))

d_C__case_46 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_46 x4 x2 x5 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return x5 cd cs
     Curry_Prelude.C_False -> Curry_Directory.d_C_getAbsolutePath (Curry_Distribution.d_C_stripCurrySuffix x2 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_46 x4 x2 x5 l cd cs) (d_C__case_46 x4 x2 x5 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_46 x4 x2 x5 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_46 x4 x2 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_46" [(show x4),(show x2),(show x5),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_46" (showCons x6))

d_C__case_48 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_48 x3 x1 x2 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "function not found") cd cs
     Curry_Prelude.C_False -> d_C_showFunctionInModule x2 x3 x1 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_48 x3 x1 x2 l cd cs) (d_C__case_48 x3 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_48 x3 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_48 x3 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_48" [(show x3),(show x1),(show x2),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_48" (showCons x4))

d_C__case_51 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_51 x2 x5 x4 x1 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "missing function name") cd cs
     Curry_Prelude.C_False -> d_C__case_50 x5 x4 x1 x2 (Curry_Prelude.d_C_null x5 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_51 x2 x5 x4 x1 l cd cs) (d_C__case_51 x2 x5 x4 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_51 x2 x5 x4 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_51 x2 x5 x4 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_51" [(show x2),(show x5),(show x4),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_51" (showCons x6))

d_C__case_50 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_50 x5 x4 x1 x2 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_getModuleOfFunction x1 x2 cd cs) (d_OP_processSource_dot_uscore_hash_lambda65 x2 x1) cd cs
     Curry_Prelude.C_False -> d_C__case_49 x5 x4 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_50 x5 x4 x1 x2 l cd cs) (d_C__case_50 x5 x4 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_50 x5 x4 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_50 x5 x4 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_50" [(show x5),(show x4),(show x1),(show x2),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_50" (showCons x6))

d_C__case_49 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_49 x5 x4 x1 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> d_C_showFunctionInModule x1 x4 (Curry_Prelude.d_C_tail x5 cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_49 x5 x4 x1 l cd cs) (d_C__case_49 x5 x4 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_49 x5 x4 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_49 x5 x4 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_49" [(show x5),(show x4),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_49" (showCons x6))

d_C__case_52 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_52 x4 x3 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> x3
     Curry_Prelude.C_False -> x4
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_52 x4 x3 l cd cs) (d_C__case_52 x4 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_52 x4 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_52 x4 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_52" [(show x4),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_52" (showCons x5))

d_C__case_53 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_53 x4 x3 x1 x2 x5 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "no editor defined") cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_maybe (d_C_skipCommand (Curry_Prelude.toCurryString "source file not found") cd cs) (d_OP_processEdit_dot_uscore_hash_lambda61_dot_uscore_hash_lambda62_dot_uscore_hash_lambda63_dot_uscore_hash_lambda64 x5 x2) x1 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_53 x4 x3 x1 x2 x5 l cd cs) (d_C__case_53 x4 x3 x1 x2 x5 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_53 x4 x3 x1 x2 x5 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_53 x4 x3 x1 x2 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_53" [(show x4),(show x3),(show x1),(show x2),(show x5),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_53" (showCons x6))

d_C__case_54 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Maybe Curry_Linker.C_ReplState
d_C__case_54 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.C_Just x1
     Curry_Prelude.C_False -> Curry_Prelude.C_Nothing
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_54 x1 l cd cs) (d_C__case_54 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_54 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_54 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_54" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_54" (showCons x2))

d_C__case_55 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_C__case_55 x3 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (Curry_Files.d_C_lookupFileInPath (Curry_Prelude.d_C_apply (Curry_Names.d_C_moduleNameToPath cd cs) x3 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".curry") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".lcurry") Curry_Prelude.OP_List)) (Curry_Linker.d_C_loadPaths x1 cd cs) cd cs) (d_OP_processAdd_dot_add_dot_331_dot_uscore_hash_lambda55 x3 x1) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar d_C_writeErrorMsg (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Illegal module name (ignored): ") x3 cd cs) cd cs) (Curry_Prelude.d_C_return x1 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_55 x3 x1 l cd cs) (d_C__case_55 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_55 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_55 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_55" [(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_55" (showCons x4))

d_C__case_58 :: Curry_Prelude.Curry t0 => t0 -> t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_58 x3 x1 x4 x2 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x1 x2
     Curry_Prelude.C_False -> d_C__case_57 x3 x1 x4 x2 (Curry_Prelude.d_OP_eq_eq x1 x3 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_58 x3 x1 x4 x2 l cd cs) (d_C__case_58 x3 x1 x4 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_58 x3 x1 x4 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_58 x3 x1 x4 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_58" [(show x3),(show x1),(show x4),(show x2),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_58" (showCons x5))

d_C__case_57 :: Curry_Prelude.Curry t0 => t0 -> t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_57 x3 x1 x4 x2 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> x2
     Curry_Prelude.C_False -> d_C__case_56 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_57 x3 x1 x4 x2 l cd cs) (d_C__case_57 x3 x1 x4 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_57 x3 x1 x4 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_57 x3 x1 x4 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_57" [(show x3),(show x1),(show x4),(show x2),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_57" (showCons x5))

d_C__case_56 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_List t0 -> t0 -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_56 x4 x1 x3 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x3 (d_OP_processAdd_dot_insert_dot_331 x1 x4 cd cs)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_56 x4 x1 x3 l cd cs) (d_C__case_56 x4 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_56 x4 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_56 x4 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_56" [(show x4),(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_56" (showCons x5))

d_C__case_60 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_60 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "Missing module name") cd cs
     Curry_Prelude.C_False -> d_C__case_59 x2 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_60 x2 x1 l cd cs) (d_C__case_60 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_60 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_60 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_60" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_60" (showCons x3))

d_C__case_59 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_59 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_liftIO (acceptCs id Curry_Prelude.C_Just) (Curry_Prelude.d_C_foldIO (acceptCs id d_OP_processAdd_dot_add_dot_331) x1 (Curry_Prelude.d_C_words x2 cd cs) cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_59 x2 x1 l cd cs) (d_C__case_59 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_59 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_59 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_59" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_59" (showCons x3))

d_C__case_63 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_63 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "no program loaded!") cd cs
     Curry_Prelude.C_False -> d_C__case_62 x2 x1 (Curry_Prelude.d_C_null (Curry_Distribution.d_C_stripCurrySuffix x2 cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_63 x1 x2 l cd cs) (d_C__case_63 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_63 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_63 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_63" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_63" (showCons x3))

d_C__case_62 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_62 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (d_C_compileCurryProgram x1 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_61 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_62 x2 x1 l cd cs) (d_C__case_62 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_62 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_62 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_62" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_62" (showCons x3))

d_C__case_61 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_61 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "superfluous argument") cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_61 l cd cs) (d_C__case_61 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_61 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_61 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_61" [(show x1)] info)
     _ -> failCons cd (consFail "REPL._case_61" (showCons x1))

d_C__case_65 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_65 x3 x2 x7 cd cs = case x7 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "missing module name") cd cs
     Curry_Prelude.C_False -> let
          x4 = Curry_FilePath.d_C_splitFileName x3 cd cs
          x5 = d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP15_hash_dirname x4 cd cs
          x6 = d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_selFP16_hash_modname x4 cd cs
           in (Curry_Prelude.d_OP_gt_gt_eq (d_C__case_64 x5 x2 (Curry_Prelude.d_OP_eq_eq x5 (Curry_Prelude.toCurryString "./") cd cs) cd cs) (d_OP_processLoad_dot_uscore_hash_lambda50_dot_uscore_hash_lambda51 x3 x6) cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_65 x3 x2 l cd cs) (d_C__case_65 x3 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_65 x3 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_65 x3 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_65" [(show x3),(show x2),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_65" (showCons x7))

d_C__case_64 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_64 x5 x2 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Prelude.C_Just x2) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Changing working directory to ") x5 cd cs) cd cs) (d_C_processCd x2 x5 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_64 x5 x2 l cd cs) (d_C__case_64 x5 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_64 x5 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_64 x5 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_64" [(show x5),(show x2),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_64" (showCons x6))

d_C__case_67 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_67 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "missing system command") cd cs
     Curry_Prelude.C_False -> d_C__case_66 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_67 x2 x1 l cd cs) (d_C__case_67 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_67 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_67 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_67" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_67" (showCons x3))

d_C__case_66 :: Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_66 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_System.d_C_system x2 cd cs) (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_66 x1 x2 l cd cs) (d_C__case_66 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_66 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_66 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_66" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_66" (showCons x3))

d_C__case_68 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_68 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "Operation not allowed in safe mode!") cd cs
     Curry_Prelude.C_False -> x2
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_68 x1 x2 l cd cs) (d_C__case_68 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_68 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_68 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_68" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_68" (showCons x3))

nd_C__case_68 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState) -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_68 x1 x2 x3 s cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "Operation not allowed in safe mode!") cd cs
     Curry_Prelude.C_False -> x2
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_68 x1 x2 l s cd cs) (nd_C__case_68 x1 x2 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_68 x1 x2 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_68 x1 x2 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_68" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_68" (showCons x3))

d_C__case_75 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_75 x2 x6 x5 x1 x7 cd cs = case x7 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "unknown command") cd cs
     Curry_Prelude.C_False -> d_C__case_74 x2 x6 x5 x1 (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_head x2 cd cs) (Curry_Prelude.C_Char '!'#) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_75 x2 x6 x5 x1 l cd cs) (d_C__case_75 x2 x6 x5 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_75 x2 x6 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_75 x2 x6 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_75" [(show x2),(show x6),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_75" (showCons x7))

nd_C__case_75 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_75 x2 x6 x5 x1 x7 s cd cs = case x7 of
     Curry_Prelude.C_True -> d_C_skipCommand (Curry_Prelude.toCurryString "unknown command") cd cs
     Curry_Prelude.C_False -> let
          s0 = s
           in (seq s0 (nd_C__case_74 x2 x6 x5 x1 (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_head x2 cd cs) (Curry_Prelude.C_Char '!'#) cd cs) s0 cd cs))
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_75 x2 x6 x5 x1 l s cd cs) (nd_C__case_75 x2 x6 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_75 x2 x6 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_75 x2 x6 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_75" [(show x2),(show x6),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_75" (showCons x7))

d_C__case_74 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_74 x2 x6 x5 x1 x7 cd cs = case x7 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (d_C_unsafeExec x1) (d_C_processSysCall x1 (Curry_Prelude.d_OP_dollar (Curry_Utils.d_C_strip cd cs) (Curry_Prelude.d_C_tail x2 cd cs) cd cs) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_73 x6 x2 x5 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_74 x2 x6 x5 x1 l cd cs) (d_C__case_74 x2 x6 x5 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_74 x2 x6 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_74 x2 x6 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_74" [(show x2),(show x6),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_74" (showCons x7))

nd_C__case_74 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_74 x2 x6 x5 x1 x7 s cd cs = case x7 of
     Curry_Prelude.C_True -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_unsafeExec x1)) (d_C_processSysCall x1 (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Utils.d_C_strip cd cs)) (Curry_Prelude.d_C_tail x2 cd cs) s0 cd cs) cd cs) s1 cd cs)))))
     Curry_Prelude.C_False -> let
          s0 = s
           in (seq s0 (nd_C__case_73 x6 x2 x5 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs))
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_74 x2 x6 x5 x1 l s cd cs) (nd_C__case_74 x2 x6 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_74 x2 x6 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_74 x2 x6 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_74" [(show x2),(show x6),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_74" (showCons x7))

d_C__case_73 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_73 x6 x2 x5 x1 x7 cd cs = case x7 of
     Curry_Prelude.C_True -> d_C__case_72 x2 x5 x1 x6 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_73 x6 x2 x5 x1 l cd cs) (d_C__case_73 x6 x2 x5 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_73 x6 x2 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_73 x6 x2 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_73" [(show x6),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_73" (showCons x7))

nd_C__case_73 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_73 x6 x2 x5 x1 x7 s cd cs = case x7 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (nd_C__case_72 x2 x5 x1 x6 s0 cd cs))
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_73 x6 x2 x5 x1 l s cd cs) (nd_C__case_73 x6 x2 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_73 x6 x2 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_73 x6 x2 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_73" [(show x6),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_73" (showCons x7))

d_C__case_72 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_72 x2 x5 x1 x6 cd cs = case x6 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar d_C_skipCommand (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "unknown command: ':") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) cd cs
     (Curry_Prelude.OP_Cons x7 x8) -> d_C__case_71 x8 x2 x5 x1 x7 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_72 x2 x5 x1 l cd cs) (d_C__case_72 x2 x5 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_72 x2 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_72 x2 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_72" [(show x2),(show x5),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_72" (showCons x6))

nd_C__case_72 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_72 x2 x5 x1 x6 s cd cs = case x6 of
     Curry_Prelude.OP_List -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_dollar (wrapDX id d_C_skipCommand) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "unknown command: ':") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) s0 cd cs))
     (Curry_Prelude.OP_Cons x7 x8) -> let
          s0 = s
           in (seq s0 (nd_C__case_71 x8 x2 x5 x1 x7 s0 cd cs))
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (nd_C__case_72 x2 x5 x1 l s cd cs) (nd_C__case_72 x2 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> nd_C__case_72 x2 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((nd_C__case_72 x2 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_72" [(show x2),(show x5),(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_72" (showCons x6))

d_C__case_71 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_71 x8 x2 x5 x1 x7 cd cs = case x7 of
     (Curry_Prelude.OP_Tuple2 x9 x10) -> d_C__case_70 x2 x9 x5 x1 x10 x8 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_71 x8 x2 x5 x1 l cd cs) (d_C__case_71 x8 x2 x5 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_71 x8 x2 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_71 x8 x2 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_71" [(show x8),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_71" (showCons x7))

nd_C__case_71 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)))) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_71 x8 x2 x5 x1 x7 s cd cs = case x7 of
     (Curry_Prelude.OP_Tuple2 x9 x10) -> let
          s0 = s
           in (seq s0 (nd_C__case_70 x2 x9 x5 x1 x10 x8 s0 cd cs))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_C__case_71 x8 x2 x5 x1 l s cd cs) (nd_C__case_71 x8 x2 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_C__case_71 x8 x2 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_C__case_71 x8 x2 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_71" [(show x8),(show x2),(show x5),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_71" (showCons x7))

d_C__case_70 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_70 x2 x9 x5 x1 x10 x8 cd cs = case x8 of
     Curry_Prelude.OP_List -> d_C__case_69 x9 x5 x1 x10 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x9 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "eval") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "load") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "quit") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "reload") Curry_Prelude.OP_List)))) cd cs) cd cs
     (Curry_Prelude.OP_Cons x11 x12) -> Curry_Prelude.d_OP_dollar d_C_skipCommand (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "ambiguous command: ':") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_70 x2 x9 x5 x1 x10 l cd cs) (d_C__case_70 x2 x9 x5 x1 x10 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_70 x2 x9 x5 x1 x10 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_70 x2 x9 x5 x1 x10 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_70" [(show x2),(show x9),(show x5),(show x1),(show x10),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_70" (showCons x8))

nd_C__case_70 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))))) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_70 x2 x9 x5 x1 x10 x8 s cd cs = case x8 of
     Curry_Prelude.OP_List -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (nd_C__case_69 x9 x5 x1 x10 (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Prelude.d_C_elem x9 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "eval") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "load") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "quit") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "reload") Curry_Prelude.OP_List)))) s0 cd cs) s1 cd cs)))))
     (Curry_Prelude.OP_Cons x11 x12) -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_dollar (wrapDX id d_C_skipCommand) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "ambiguous command: ':") (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString "'") cd cs) cd cs) s0 cd cs))
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (nd_C__case_70 x2 x9 x5 x1 x10 l s cd cs) (nd_C__case_70 x2 x9 x5 x1 x10 r s cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> nd_C__case_70 x2 x9 x5 x1 x10 z s cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((nd_C__case_70 x2 x9 x5 x1 x10 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_70" [(show x2),(show x9),(show x5),(show x1),(show x10),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_70" (showCons x8))

d_C__case_69 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> (Curry_Linker.C_ReplState -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
d_C__case_69 x9 x5 x1 x10 x11 cd cs = case x11 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x10 x1 cd cs) (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x5 cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar (d_C_unsafeExec x1) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x10 x1 cd cs) (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) x5 cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_69 x9 x5 x1 x10 l cd cs) (d_C__case_69 x9 x5 x1 x10 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_69 x9 x5 x1 x10 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_69 x9 x5 x1 x10 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_69" [(show x9),(show x5),(show x1),(show x10),(show x11)] info)
     _ -> failCons cd (consFail "REPL._case_69" (showCons x11))

nd_C__case_69 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Func Curry_Linker.C_ReplState (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState))) -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe Curry_Linker.C_ReplState)
nd_C__case_69 x9 x5 x1 x10 x11 s cd cs = case x11 of
     Curry_Prelude.C_True -> let
          s3 = s
           in (seq s3 (let
               s2 = leftSupply s3
               s4 = rightSupply s3
               s0 = leftSupply s4
               s1 = rightSupply s4
                in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x10 x1 s0 cd cs) (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Utils.d_C_strip cd cs)) x5 s1 cd cs) s2 cd cs)))))))
     Curry_Prelude.C_False -> let
          s6 = s
           in (seq s6 (let
               s5 = leftSupply s6
               s3 = rightSupply s6
                in (seq s5 (seq s3 (Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_unsafeExec x1)) (let
                    s2 = leftSupply s3
                    s4 = rightSupply s3
                    s0 = leftSupply s4
                    s1 = rightSupply s4
                     in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x10 x1 s0 cd cs) (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Utils.d_C_strip cd cs)) x5 s1 cd cs) s2 cd cs)))))) s5 cd cs)))))
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_69 x9 x5 x1 x10 l s cd cs) (nd_C__case_69 x9 x5 x1 x10 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_69 x9 x5 x1 x10 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_69 x9 x5 x1 x10 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_69" [(show x9),(show x5),(show x1),(show x10),(show x11)] info)
     _ -> failCons cd (consFail "REPL._case_69" (showCons x11))

d_C__case_76 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_76 x9 x4 x1 x10 x11 cd cs = case x11 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+RTS") (Curry_Prelude.OP_Cons (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_rtsOpts x1 cd cs) (Curry_Prelude.OP_Cons x4 (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "-RTS") Curry_Prelude.OP_List))))) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_76 x9 x4 x1 x10 l cd cs) (d_C__case_76 x9 x4 x1 x10 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_76 x9 x4 x1 x10 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_76 x9 x4 x1 x10 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_76" [(show x9),(show x4),(show x1),(show x10),(show x11)] info)
     _ -> failCons cd (consFail "REPL._case_76" (showCons x11))

d_C__case_77 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_77 x9 cd cs = case x9 of
     Curry_Prelude.C_True -> Curry_Prelude.toCurryString "-p"
     Curry_Prelude.C_False -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_77 l cd cs) (d_C__case_77 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_77 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_77 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_77" [(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_77" (showCons x9))

d_C__case_79 :: Curry_Linker.C_ReplState -> Curry_Linker.C_NonDetMode -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_79 x1 x8 cd cs = case x8 of
     (Curry_Linker.C_Par x5) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "-N") (d_C__case_78 x5 (Curry_Prelude.d_OP_eq_eq x5 (Curry_Prelude.C_Int 0#) cd cs) cd cs) cd cs
     Curry_Linker.C_DFS -> Curry_Prelude.OP_List
     Curry_Linker.C_BFS -> Curry_Prelude.OP_List
     (Curry_Linker.C_IDS x6) -> Curry_Prelude.OP_List
     Curry_Linker.C_PrDFS -> Curry_Prelude.OP_List
     (Curry_Linker.C_PrtChoices x7) -> Curry_Prelude.OP_List
     Curry_Linker.C_DEBUG -> Curry_Prelude.OP_List
     (Curry_Linker.Choice_C_NonDetMode d i l r) -> narrow d i (d_C__case_79 x1 l cd cs) (d_C__case_79 x1 r cd cs)
     (Curry_Linker.Choices_C_NonDetMode d i xs) -> narrows cs d i (\z -> d_C__case_79 x1 z cd cs) xs
     (Curry_Linker.Guard_C_NonDetMode d c e) -> guardCons d c ((d_C__case_79 x1 e cd) $! (addCs c cs))
     (Curry_Linker.Fail_C_NonDetMode d info) -> failCons d (traceFail "REPL._case_79" [(show x1),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_79" (showCons x8))

d_C__case_78 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_78 x5 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.d_C_show x5 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_78 x5 l cd cs) (d_C__case_78 x5 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_78 x5 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_78 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_78" [(show x5),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_78" (showCons x6))

d_C__case_82 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_82 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.C_Int 2#
     Curry_Prelude.C_False -> d_C__case_81 x1 (Curry_Prelude.d_OP_gt_eq x1 (Curry_Prelude.C_Int 4#) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_82 x1 l cd cs) (d_C__case_82 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_82 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_82 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_82" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_82" (showCons x2))

d_C__case_81 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_81 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.C_Int 3#
     Curry_Prelude.C_False -> d_C__case_80 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_81 x1 l cd cs) (d_C__case_81 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_81 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_81 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_81" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_81" (showCons x2))

d_C__case_80 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_80 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> x1
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_80 x1 l cd cs) (d_C__case_80 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_80 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_80 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_80" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_80" (showCons x2))

d_C__case_83 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_83 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "--trace-failure") Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_83 x1 l cd cs) (d_C__case_83 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_83 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_83 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_83" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_83" (showCons x2))

d_C__case_84 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_84 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "--parse-options=\"") (Curry_Prelude.d_OP_plus_plus (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_parseOpts x1 cd cs) (Curry_Prelude.toCurryString "\"") cd cs) cd cs) Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_84 x1 l cd cs) (d_C__case_84 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_84 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_84 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_84" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_84" (showCons x2))

d_C__case_85 :: Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_85 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString ") >>= print") cd cs)
     Curry_Prelude.C_False -> x1
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_85 x2 x1 l cd cs) (d_C__case_85 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_85 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_85 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_85" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_85" (showCons x3))

d_C__case_91 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_91 x3 x1 x7 cd cs = case x7 of
     (Curry_Prelude.OP_Cons x9 x10) -> d_C__case_90 x10 x3 x1 x9 cd cs
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.makeMainGoalMonomorphic") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_91 x3 x1 l cd cs) (d_C__case_91 x3 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_91 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_91 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_91" [(show x3),(show x1),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_91" (showCons x7))

d_C__case_90 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_90 x10 x3 x1 x9 cd cs = case x9 of
     (Curry_AbstractCurry.C_CFunc x11 x12 x13 x14 x15) -> d_C__case_89 x14 x3 x1 x10 cd cs
     (Curry_AbstractCurry.C_CmtFunc x18 x19 x20 x21 x22 x23) -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.makeMainGoalMonomorphic") cd cs
     (Curry_AbstractCurry.Choice_C_CFuncDecl d i l r) -> narrow d i (d_C__case_90 x10 x3 x1 l cd cs) (d_C__case_90 x10 x3 x1 r cd cs)
     (Curry_AbstractCurry.Choices_C_CFuncDecl d i xs) -> narrows cs d i (\z -> d_C__case_90 x10 x3 x1 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CFuncDecl d c e) -> guardCons d c ((d_C__case_90 x10 x3 x1 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CFuncDecl d info) -> failCons d (traceFail "REPL._case_90" [(show x10),(show x3),(show x1),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_90" (showCons x9))

d_C__case_89 :: Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_89 x14 x3 x1 x10 cd cs = case x10 of
     Curry_Prelude.OP_List -> d_C__case_88 x14 x3 x1 (Curry_AbstractCurryGoodies.d_C_isFunctionalType x14 cd cs) cd cs
     (Curry_Prelude.OP_Cons x16 x17) -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.makeMainGoalMonomorphic") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_89 x14 x3 x1 l cd cs) (d_C__case_89 x14 x3 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_89 x14 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_89 x14 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_89" [(show x14),(show x3),(show x1),(show x10)] info)
     _ -> failCons cd (consFail "REPL._case_89" (showCons x10))

d_C__case_88 :: Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_88 x14 x3 x1 x15 cd cs = case x15 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (d_C_writeErrorMsg (Curry_Prelude.toCurryString "expression is of functional type") cd cs) (Curry_Prelude.d_C_return Curry_Prelude.C_False cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_87 x14 x3 x1 (Curry_AbstractCurryGoodies.d_C_isPolyType x14 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_88 x14 x3 x1 l cd cs) (d_C__case_88 x14 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_88 x14 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_88 x14 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_88" [(show x14),(show x3),(show x1),(show x15)] info)
     _ -> failCons cd (consFail "REPL._case_88" (showCons x15))

d_C__case_87 :: Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_87 x14 x3 x1 x15 cd cs = case x15 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (d_C_writeMainGoalFile x1 (Curry_AbstractCurryGoodies.d_C_modsOfType x14 cd cs) (Curry_Prelude.d_OP_dollar (acceptCs id Curry_Prelude.C_Just) (Curry_Utils.d_C_showMonoTypeExpr Curry_Prelude.C_True x14 cd cs) cd cs) x3 cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 2#)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Type of main expression \"") (Curry_Prelude.d_OP_plus_plus (Curry_Utils.d_C_showMonoTypeExpr Curry_Prelude.C_False x14 cd cs) (Curry_Prelude.toCurryString "\" made monomorphic") cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 1#) (Curry_Prelude.toCurryString "Type variables of main expression replaced by \"()\"") cd cs) (Curry_Prelude.d_C_return Curry_Prelude.C_True cd cs) cd cs) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_86 x14 x3 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_87 x14 x3 x1 l cd cs) (d_C__case_87 x14 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_87 x14 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_87 x14 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_87" [(show x14),(show x3),(show x1),(show x15)] info)
     _ -> failCons cd (consFail "REPL._case_87" (showCons x15))

d_C__case_86 :: Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_86 x14 x3 x1 x15 cd cs = case x15 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless (Curry_Prelude.d_OP_eq_eq (d_OP_makeMainGoalMonomorphic_dot_newgoal_dot_237 x3 x14 cd cs) x3 cd cs)) (d_C_writeSimpleMainGoalFile x1 (d_OP_makeMainGoalMonomorphic_dot_newgoal_dot_237 x3 x14 cd cs) cd cs) cd cs) (Curry_Prelude.d_C_return Curry_Prelude.C_True cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.makeMainGoalMonomorphic") cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_86 x14 x3 x1 l cd cs) (d_C__case_86 x14 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_86 x14 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_86 x14 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_86" [(show x14),(show x3),(show x1),(show x15)] info)
     _ -> failCons cd (consFail "REPL._case_86" (showCons x15))

d_C__case_93 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_93 x3 x2 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_drop (Curry_Prelude.C_Int 6#) x3 cd cs
     Curry_Prelude.C_False -> d_C__case_92 x3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_93 x3 x2 l cd cs) (d_C__case_93 x3 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_93 x3 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_93 x3 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_93" [(show x3),(show x2),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_93" (showCons x4))

d_C__case_92 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_92 x3 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 x3 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_92 x3 l cd cs) (d_C__case_92 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_92 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_92 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_92" [(show x3),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_92" (showCons x4))

d_C__case_95 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_95 x2 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> let
          x3 = d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167_dot_findWhere_dot_199 (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int 4#) x2 cd cs) cd cs
           in (d_C__case_94 x3 x1 (Curry_Prelude.d_C_null x3 cd cs) cd cs)
     Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x1 Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_95 x2 x1 l cd cs) (d_C__case_95 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_95 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_95 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_95" [(show x2),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_95" (showCons x4))

d_C__case_94 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_94 x3 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x1 Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x3 cd cs) (Curry_Prelude.d_C_drop (Curry_Prelude.d_C_length x3 cd cs) x1 cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_94 x3 x1 l cd cs) (d_C__case_94 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_94 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_94 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_94" [(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_94" (showCons x4))

d_C__case_99 :: Curry_AbstractCurry.C_CRules -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_99 x6 cd cs = case x6 of
     (Curry_AbstractCurry.C_CRules x7 x8) -> d_C__case_98 x8 cd cs
     (Curry_AbstractCurry.C_CExternal x16) -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.insertFreeVarsInMainGoal.freeVarsInFuncRule") cd cs
     (Curry_AbstractCurry.Choice_C_CRules d i l r) -> narrow d i (d_C__case_99 l cd cs) (d_C__case_99 r cd cs)
     (Curry_AbstractCurry.Choices_C_CRules d i xs) -> narrows cs d i (\z -> d_C__case_99 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CRules d c e) -> guardCons d c ((d_C__case_99 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CRules d info) -> failCons d (traceFail "REPL._case_99" [(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_99" (showCons x6))

d_C__case_98 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_98 x8 cd cs = case x8 of
     (Curry_Prelude.OP_Cons x9 x10) -> d_C__case_97 x10 x9 cd cs
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.insertFreeVarsInMainGoal.freeVarsInFuncRule") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_98 l cd cs) (d_C__case_98 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_98 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_98 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_98" [(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_98" (showCons x8))

d_C__case_97 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_AbstractCurry.C_CRule -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_97 x10 x9 cd cs = case x9 of
     (Curry_AbstractCurry.C_CRule x11 x12 x13) -> d_C__case_96 x13 x10 cd cs
     (Curry_AbstractCurry.Choice_C_CRule d i l r) -> narrow d i (d_C__case_97 x10 l cd cs) (d_C__case_97 x10 r cd cs)
     (Curry_AbstractCurry.Choices_C_CRule d i xs) -> narrows cs d i (\z -> d_C__case_97 x10 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CRule d c e) -> guardCons d c ((d_C__case_97 x10 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CRule d info) -> failCons d (traceFail "REPL._case_97" [(show x10),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_97" (showCons x9))

d_C__case_96 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_96 x13 x10 cd cs = case x10 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap d_OP_insertFreeVarsInMainGoal_dot_lvarName_dot_167 cd cs) x13 cd cs
     (Curry_Prelude.OP_Cons x14 x15) -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.insertFreeVarsInMainGoal.freeVarsInFuncRule") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_96 x13 l cd cs) (d_C__case_96 x13 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_96 x13 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_96 x13 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_96" [(show x13),(show x10)] info)
     _ -> failCons cd (consFail "REPL._case_96" (showCons x10))

d_C__case_100 :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_100 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_Prelude.OP_Cons x4 Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_100 l cd cs) (d_C__case_100 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_100 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_100 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_100" [(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_100" (showCons x2))

d_C__case_106 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_AbstractCurry.C_CurryProg -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_C__case_106 x2 x1 x4 cd cs = case x4 of
     (Curry_AbstractCurry.C_CurryProg x5 x6 x7 x8 x9) -> d_C__case_105 x2 x1 x4 x8 cd cs
     (Curry_AbstractCurry.Choice_C_CurryProg d i l r) -> narrow d i (d_C__case_106 x2 x1 l cd cs) (d_C__case_106 x2 x1 r cd cs)
     (Curry_AbstractCurry.Choices_C_CurryProg d i xs) -> narrows cs d i (\z -> d_C__case_106 x2 x1 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CurryProg d c e) -> guardCons d c ((d_C__case_106 x2 x1 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CurryProg d info) -> failCons d (traceFail "REPL._case_106" [(show x2),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_106" (showCons x4))

d_C__case_105 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_AbstractCurry.C_CurryProg -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_C__case_105 x2 x1 x4 x8 cd cs = case x8 of
     (Curry_Prelude.OP_Cons x10 x11) -> d_C__case_104 x11 x2 x1 x4 x10 cd cs
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.insertFreeVarsInMainGoal") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_105 x2 x1 x4 l cd cs) (d_C__case_105 x2 x1 x4 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_105 x2 x1 x4 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_105 x2 x1 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_105" [(show x2),(show x1),(show x4),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_105" (showCons x8))

d_C__case_104 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_AbstractCurry.C_CurryProg -> Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_C__case_104 x11 x2 x1 x4 x10 cd cs = case x10 of
     (Curry_AbstractCurry.C_CFunc x12 x13 x14 x15 x16) -> d_C__case_103 x2 x10 x15 x1 x4 x11 cd cs
     (Curry_AbstractCurry.C_CmtFunc x24 x25 x26 x27 x28 x29) -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.insertFreeVarsInMainGoal") cd cs
     (Curry_AbstractCurry.Choice_C_CFuncDecl d i l r) -> narrow d i (d_C__case_104 x11 x2 x1 x4 l cd cs) (d_C__case_104 x11 x2 x1 x4 r cd cs)
     (Curry_AbstractCurry.Choices_C_CFuncDecl d i xs) -> narrows cs d i (\z -> d_C__case_104 x11 x2 x1 x4 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CFuncDecl d c e) -> guardCons d c ((d_C__case_104 x11 x2 x1 x4 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CFuncDecl d info) -> failCons d (traceFail "REPL._case_104" [(show x11),(show x2),(show x1),(show x4),(show x10)] info)
     _ -> failCons cd (consFail "REPL._case_104" (showCons x10))

d_C__case_103 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_AbstractCurry.C_CFuncDecl -> Curry_AbstractCurry.C_CTypeExpr -> Curry_Linker.C_ReplState -> Curry_AbstractCurry.C_CurryProg -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_C__case_103 x2 x10 x15 x1 x4 x11 cd cs = case x11 of
     Curry_Prelude.OP_List -> let
          x17 = d_OP_insertFreeVarsInMainGoal_dot_freeVarsInFuncRule_dot_167 x10 cd cs
          x18 = d_OP_insertFreeVarsInMainGoal_dot_breakWhereFreeClause_dot_167 x2 cd cs
          x19 = d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP9_hash_exp x18 cd cs
          x20 = d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_selFP10_hash_whereclause x18 cd cs
           in (d_C__case_102 x15 x1 x20 x17 x19 x4 (Curry_Prelude.d_OP_amp_amp (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_safeExec x1 cd cs) (Curry_AbstractCurryGoodies.d_C_isIOType x15 cd cs) cd cs) cd cs)
     (Curry_Prelude.OP_Cons x22 x23) -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.insertFreeVarsInMainGoal") cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_103 x2 x10 x15 x1 x4 l cd cs) (d_C__case_103 x2 x10 x15 x1 x4 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_103 x2 x10 x15 x1 x4 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_103 x2 x10 x15 x1 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_103" [(show x2),(show x10),(show x15),(show x1),(show x4),(show x11)] info)
     _ -> failCons cd (consFail "REPL._case_103" (showCons x11))

d_C__case_102 :: Curry_AbstractCurry.C_CTypeExpr -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_AbstractCurry.C_CurryProg -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_C__case_102 x15 x1 x20 x17 x19 x4 x21 cd cs = case x21 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (d_C_writeErrorMsg (Curry_Prelude.toCurryString "Operation not allowed in safe mode!") cd cs) (Curry_Prelude.d_C_return C_GoalError cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_101 x20 x17 x15 x1 x19 x4 (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_null x17 cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_not (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_showBindings x1 cd cs) cd cs) (Curry_Prelude.d_OP_bar_bar (d_OP_insertFreeVarsInMainGoal_dot_isPrtChoices_dot_167 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_ndMode x1 cd cs) cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_AbstractCurryGoodies.d_C_isIOType x15 cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_gt (Curry_Prelude.d_C_length x17 cd cs) (Curry_Prelude.C_Int 10#) cd cs) (Curry_Prelude.d_C_null x20 cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_102 x15 x1 x20 x17 x19 x4 l cd cs) (d_C__case_102 x15 x1 x20 x17 x19 x4 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_102 x15 x1 x20 x17 x19 x4 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_102 x15 x1 x20 x17 x19 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_102" [(show x15),(show x1),(show x20),(show x17),(show x19),(show x4),(show x21)] info)
     _ -> failCons cd (consFail "REPL._case_102" (showCons x21))

d_C__case_101 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_AbstractCurry.C_CTypeExpr -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_AbstractCurry.C_CurryProg -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO C_GoalCompile
d_C__case_101 x20 x17 x15 x1 x19 x4 x22 cd cs = case x22 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return (C_GoalWithoutBindings x4) cd cs
     Curry_Prelude.C_False -> let
          x21 = Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_unwords (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "(") (Curry_Prelude.OP_Cons x19 (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ",[") Curry_Prelude.OP_List))) (Curry_Prelude.d_OP_plus_plus (Curry_List.d_C_intersperse (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_C_map d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda39 x17 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "]") Curry_Prelude.OP_List) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda40 x17 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ")") (Curry_Prelude.OP_Cons x20 Curry_Prelude.OP_List)) cd cs) cd cs) cd cs) cd cs) cd cs
           in (Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 2#)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Adding printing of bindings for free variables: ") (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",") x17 cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt (d_C_writeSimpleMainGoalFile x1 x21 cd cs) (Curry_Prelude.d_OP_gt_gt_eq (d_C_getAcyOfMainGoal x1 cd cs) (d_OP_insertFreeVarsInMainGoal_dot_uscore_hash_lambda41 x17 x21) cd cs) cd cs) cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_101 x20 x17 x15 x1 x19 x4 l cd cs) (d_C__case_101 x20 x17 x15 x1 x19 x4 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_101 x20 x17 x15 x1 x19 x4 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_101 x20 x17 x15 x1 x19 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_101" [(show x20),(show x17),(show x15),(show x1),(show x19),(show x4),(show x22)] info)
     _ -> failCons cd (consFail "REPL._case_101" (showCons x22))

d_C__case_107 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Int -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_C__case_107 x6 x5 x4 x1 x3 x2 x7 cd cs = case x7 of
     Curry_Prelude.C_True -> Curry_Linker.d_C_createAndCompileMain x4 x2 x3 x1 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 (Curry_Linker.d_C_setExitStatus (Curry_Prelude.C_Int 1#) x4 cd cs) Curry_Linker.C_MainError) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_107 x6 x5 x4 x1 x3 x2 l cd cs) (d_C__case_107 x6 x5 x4 x1 x3 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_107 x6 x5 x4 x1 x3 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_107 x6 x5 x4 x1 x3 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_107" [(show x6),(show x5),(show x4),(show x1),(show x3),(show x2),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_107" (showCons x7))

d_C__case_109 :: C_GoalCompile -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_C__case_109 x5 x2 x4 x3 x1 x14 cd cs = case x14 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 (Curry_Linker.d_C_setExitStatus (Curry_Prelude.C_Int 1#) x4 cd cs) Curry_Linker.C_MainError) cd cs
     Curry_Prelude.C_False -> let
          x6 = d_C__case_108 x2 x5 cd cs
          x11 = d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP5_hash_newprog x6 cd cs
          x12 = d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP6_hash_newgoal x6 cd cs
          x13 = d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_selFP7_hash_bindings x6 cd cs
           in (Curry_Prelude.d_OP_gt_gt_eq (d_C_makeMainGoalMonomorphic x4 x11 x12 cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x13 x1 x2 x3 x4) cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_109 x5 x2 x4 x3 x1 l cd cs) (d_C__case_109 x5 x2 x4 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_109 x5 x2 x4 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_109 x5 x2 x4 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_109" [(show x5),(show x2),(show x4),(show x3),(show x1),(show x14)] info)
     _ -> failCons cd (consFail "REPL._case_109" (showCons x14))

d_C__case_108 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_GoalCompile -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 Curry_AbstractCurry.C_CurryProg (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe Curry_Prelude.C_Int)
d_C__case_108 x2 x5 cd cs = case x5 of
     (C_GoalWithBindings x7 x8 x9) -> Curry_Prelude.OP_Tuple3 x7 x9 (Curry_Prelude.C_Just x8)
     (C_GoalWithoutBindings x10) -> Curry_Prelude.OP_Tuple3 x10 x2 Curry_Prelude.C_Nothing
     C_GoalError -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "REPL.compileProgramWithGoal") cd cs
     (Choice_C_GoalCompile d i l r) -> narrow d i (d_C__case_108 x2 l cd cs) (d_C__case_108 x2 r cd cs)
     (Choices_C_GoalCompile d i xs) -> narrows cs d i (\z -> d_C__case_108 x2 z cd cs) xs
     (Guard_C_GoalCompile d c e) -> guardCons d c ((d_C__case_108 x2 e cd) $! (addCs c cs))
     (Fail_C_GoalCompile d info) -> failCons d (traceFail "REPL._case_108" [(show x2),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_108" (showCons x5))

d_C__case_110 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
d_C__case_110 x1 x5 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_importUnsafeModule x1 cd cs) (d_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x5 x1) cd cs
     Curry_Prelude.C_False -> x5
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_110 x1 x5 l cd cs) (d_C__case_110 x1 x5 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_110 x1 x5 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_110 x1 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_110" [(show x1),(show x5),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_110" (showCons x6))

nd_C__case_110 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile) -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 Curry_Linker.C_ReplState Curry_Linker.C_MainCompile)
nd_C__case_110 x1 x5 x6 s cd cs = case x6 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_gt_gt_eq (d_C_importUnsafeModule x1 cd cs) (wrapNX id (nd_OP_compileProgramWithGoal_dot_uscore_hash_lambda34 x5 x1)) s0 cd cs))
     Curry_Prelude.C_False -> x5
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_110 x1 x5 l s cd cs) (nd_C__case_110 x1 x5 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_110 x1 x5 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_110 x1 x5 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_110" [(show x1),(show x5),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_110" (showCons x6))

d_C__case_113 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_113 x5 cd cs = case x5 of
     (Curry_Prelude.OP_Cons x7 x8) -> d_C__case_112 x8 x7 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_113 l cd cs) (d_C__case_113 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_113 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_113 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_113" [(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_113" (showCons x5))

d_C__case_112 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_112 x8 x7 cd cs = case x7 of
     (Curry_AbstractCurry.C_CFunc x9 x10 x11 x12 x13) -> d_C__case_111 x13 x8 cd cs
     (Curry_AbstractCurry.Choice_C_CFuncDecl d i l r) -> narrow d i (d_C__case_112 x8 l cd cs) (d_C__case_112 x8 r cd cs)
     (Curry_AbstractCurry.Choices_C_CFuncDecl d i xs) -> narrows cs d i (\z -> d_C__case_112 x8 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CFuncDecl d c e) -> guardCons d c ((d_C__case_112 x8 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CFuncDecl d info) -> failCons d (traceFail "REPL._case_112" [(show x8),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_112" (showCons x7))

d_C__case_111 :: Curry_AbstractCurry.C_CRules -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_111 x13 x8 cd cs = case x8 of
     Curry_Prelude.OP_List -> d_OP_getModuleOfFunction_dot_modOfMain_dot_117 x13 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_111 x13 l cd cs) (d_C__case_111 x13 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_111 x13 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_111 x13 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_111" [(show x13),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_111" (showCons x8))

d_C__case_123 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_123 x3 cd cs = case x3 of
     (Curry_Prelude.OP_Cons x4 x5) -> d_C__case_122 x5 x4 cd cs
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_123 l cd cs) (d_C__case_123 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_123 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_123 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_123" [(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_123" (showCons x3))

d_C__case_122 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_AbstractCurry.C_CRule -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_122 x5 x4 cd cs = case x4 of
     (Curry_AbstractCurry.C_CRule x6 x7 x8) -> d_C__case_121 x7 x8 x5 x6 cd cs
     (Curry_AbstractCurry.Choice_C_CRule d i l r) -> narrow d i (d_C__case_122 x5 l cd cs) (d_C__case_122 x5 r cd cs)
     (Curry_AbstractCurry.Choices_C_CRule d i xs) -> narrows cs d i (\z -> d_C__case_122 x5 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CRule d c e) -> guardCons d c ((d_C__case_122 x5 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CRule d info) -> failCons d (traceFail "REPL._case_122" [(show x5),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_122" (showCons x4))

d_C__case_121 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_AbstractCurry.C_CExpr Curry_AbstractCurry.C_CExpr) -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CPattern -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_121 x7 x8 x5 x6 cd cs = case x6 of
     Curry_Prelude.OP_List -> d_C__case_120 x8 x5 x7 cd cs
     (Curry_Prelude.OP_Cons x40 x41) -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_121 x7 x8 x5 l cd cs) (d_C__case_121 x7 x8 x5 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_121 x7 x8 x5 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_121 x7 x8 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_121" [(show x7),(show x8),(show x5),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_121" (showCons x6))

d_C__case_120 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_AbstractCurry.C_CExpr Curry_AbstractCurry.C_CExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_120 x8 x5 x7 cd cs = case x7 of
     (Curry_Prelude.OP_Cons x9 x10) -> d_C__case_119 x10 x8 x5 x9 cd cs
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_120 x8 x5 l cd cs) (d_C__case_120 x8 x5 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_120 x8 x5 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_120 x8 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_120" [(show x8),(show x5),(show x7)] info)
     _ -> failCons cd (consFail "REPL._case_120" (showCons x7))

d_C__case_119 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_AbstractCurry.C_CExpr Curry_AbstractCurry.C_CExpr) -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_Prelude.OP_Tuple2 Curry_AbstractCurry.C_CExpr Curry_AbstractCurry.C_CExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_119 x10 x8 x5 x9 cd cs = case x9 of
     (Curry_Prelude.OP_Tuple2 x11 x12) -> d_C__case_118 x10 x8 x5 x12 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_119 x10 x8 x5 l cd cs) (d_C__case_119 x10 x8 x5 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_119 x10 x8 x5 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_119 x10 x8 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_119" [(show x10),(show x8),(show x5),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_119" (showCons x9))

d_C__case_118 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_AbstractCurry.C_CExpr Curry_AbstractCurry.C_CExpr) -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_AbstractCurry.C_CExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_118 x10 x8 x5 x12 cd cs = case x12 of
     (Curry_AbstractCurry.C_CSymbol x13) -> d_C__case_117 x10 x8 x5 x13 cd cs
     (Curry_AbstractCurry.C_CVar x22) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CLit x23) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CApply x24 x25) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CLambda x26 x27) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CLetDecl x28 x29) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CDoExpr x30) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CListComp x31 x32) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CCase x33 x34) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CRecConstr x35) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CRecSelect x36 x37) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CRecUpdate x38 x39) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.Choice_C_CExpr d i l r) -> narrow d i (d_C__case_118 x10 x8 x5 l cd cs) (d_C__case_118 x10 x8 x5 r cd cs)
     (Curry_AbstractCurry.Choices_C_CExpr d i xs) -> narrows cs d i (\z -> d_C__case_118 x10 x8 x5 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CExpr d c e) -> guardCons d c ((d_C__case_118 x10 x8 x5 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CExpr d info) -> failCons d (traceFail "REPL._case_118" [(show x10),(show x8),(show x5),(show x12)] info)
     _ -> failCons cd (consFail "REPL._case_118" (showCons x12))

d_C__case_117 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_AbstractCurry.C_CExpr Curry_AbstractCurry.C_CExpr) -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_117 x10 x8 x5 x13 cd cs = case x13 of
     (Curry_Prelude.OP_Tuple2 x14 x15) -> d_C__case_116 x8 x5 x14 x10 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_117 x10 x8 x5 l cd cs) (d_C__case_117 x10 x8 x5 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_117 x10 x8 x5 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_117 x10 x8 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "REPL._case_117" [(show x10),(show x8),(show x5),(show x13)] info)
     _ -> failCons cd (consFail "REPL._case_117" (showCons x13))

d_C__case_116 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_AbstractCurry.C_CExpr Curry_AbstractCurry.C_CExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_116 x8 x5 x14 x10 cd cs = case x10 of
     Curry_Prelude.OP_List -> d_C__case_115 x5 x14 x8 cd cs
     (Curry_Prelude.OP_Cons x20 x21) -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_116 x8 x5 x14 l cd cs) (d_C__case_116 x8 x5 x14 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_116 x8 x5 x14 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_116 x8 x5 x14 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_116" [(show x8),(show x5),(show x14),(show x10)] info)
     _ -> failCons cd (consFail "REPL._case_116" (showCons x10))

d_C__case_115 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CLocalDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_115 x5 x14 x8 cd cs = case x8 of
     Curry_Prelude.OP_List -> d_C__case_114 x14 x5 cd cs
     (Curry_Prelude.OP_Cons x18 x19) -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_115 x5 x14 l cd cs) (d_C__case_115 x5 x14 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_115 x5 x14 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_115 x5 x14 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_115" [(show x5),(show x14),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_115" (showCons x8))

d_C__case_114 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CRule -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_114 x14 x5 cd cs = case x5 of
     Curry_Prelude.OP_List -> x14
     (Curry_Prelude.OP_Cons x16 x17) -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_114 x14 l cd cs) (d_C__case_114 x14 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_114 x14 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_114 x14 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_114" [(show x14),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_114" (showCons x5))

d_C__case_124 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_124 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> x2
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString ")") cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_124 x2 l cd cs) (d_C__case_124 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_124 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_124 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_124" [(show x2),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_124" (showCons x3))

d_C__case_127 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_127 x1 x6 cd cs = case x6 of
     (Curry_Prelude.OP_Cons x8 x9) -> d_C__case_126 x9 x1 x8 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_127 x1 l cd cs) (d_C__case_127 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_127 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_127 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_127" [(show x1),(show x6)] info)
     _ -> failCons cd (consFail "REPL._case_127" (showCons x6))

d_C__case_126 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_126 x9 x1 x8 cd cs = case x8 of
     (Curry_AbstractCurry.C_CFunc x10 x11 x12 x13 x14) -> d_C__case_125 x13 x1 x9 cd cs
     (Curry_AbstractCurry.Choice_C_CFuncDecl d i l r) -> narrow d i (d_C__case_126 x9 x1 l cd cs) (d_C__case_126 x9 x1 r cd cs)
     (Curry_AbstractCurry.Choices_C_CFuncDecl d i xs) -> narrows cs d i (\z -> d_C__case_126 x9 x1 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CFuncDecl d c e) -> guardCons d c ((d_C__case_126 x9 x1 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CFuncDecl d info) -> failCons d (traceFail "REPL._case_126" [(show x9),(show x1),(show x8)] info)
     _ -> failCons cd (consFail "REPL._case_126" (showCons x8))

d_C__case_125 :: Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CFuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_125 x13 x1 x9 cd cs = case x9 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " :: ") (Curry_Utils.d_C_showMonoTypeExpr Curry_Prelude.C_False x13 cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_return Curry_Prelude.C_True cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_125 x13 x1 l cd cs) (d_C__case_125 x13 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_125 x13 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_125 x13 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_125" [(show x13),(show x1),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_125" (showCons x9))

d_C__case_128 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C__case_128 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return Curry_Prelude.C_True cd cs
     Curry_Prelude.C_False -> let
          x2 = Curry_FlatCurry.d_C_flatCurryFileName (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) cd cs
          x3 = d_C_currentFrontendParams x1 cd cs
           in (Curry_Prelude.d_C_catch (Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_OP_gt_gt (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_FCY x3 (Curry_Linker.d_OP_uscore_hash_selR_at_ReplState_dot_mainMod x1 cd cs) cd cs) (Curry_FlatCurry.d_C_readFlatCurryFile x2 cd cs) cd cs) d_OP_importUnsafeModule_dot_uscore_hash_lambda18 cd cs) (d_OP_importUnsafeModule_dot_uscore_hash_lambda19 x1) cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_128 x1 l cd cs) (d_C__case_128 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_128 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_128 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_128" [(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_128" (showCons x4))

d_C__case_129 :: Curry_Linker.C_ReplState -> Curry_Linker.C_MainCompile -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Linker.C_ReplState
d_C__case_129 x3 x4 x1 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_return x3 cd cs
     Curry_Prelude.C_False -> d_C_execMain x3 x4 x1 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_129 x3 x4 x1 l cd cs) (d_C__case_129 x3 x4 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_129 x3 x4 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_129 x3 x4 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_129" [(show x3),(show x4),(show x1),(show x5)] info)
     _ -> failCons cd (consFail "REPL._case_129" (showCons x5))

d_C__case_130 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_130 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> d_C_cleanUpRepl x1 cd cs
     Curry_Prelude.C_False -> d_C_repl x1 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_130 x1 l cd cs) (d_C__case_130 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_130 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_130 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_130" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_130" (showCons x2))

d_C__case_133 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_133 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_repl x1 cd cs
     Curry_Prelude.C_False -> d_C__case_132 x2 x1 (d_OP_processInput_dot_isCommand_dot_62 x2 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_133 x2 x1 l cd cs) (d_C__case_133 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_133 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_133 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_133" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_133" (showCons x3))

d_C__case_132 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_132 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_processCommand x1 (Curry_Prelude.d_C_apply (Curry_Utils.d_C_strip cd cs) (Curry_Prelude.d_C_tail x2 cd cs) cd cs) cd cs) (d_OP_processInput_dot_uscore_hash_lambda14 x1) cd cs
     Curry_Prelude.C_False -> d_C__case_131 x2 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_132 x2 x1 l cd cs) (d_C__case_132 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_132 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_132 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_132" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_132" (showCons x3))

d_C__case_131 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_131 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (d_C_evalExpression x1 x2 cd cs) d_C_repl cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_131 x2 x1 l cd cs) (d_C__case_131 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_131 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_131 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_131" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "REPL._case_131" (showCons x3))

d_C__case_137 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_137 x3 x1 x4 cd cs = case x4 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x5 x6) -> let
          x7 = x3
           in (d_C__case_136 x7 x6 x5 x1 x3 (Curry_Prelude.d_OP_eq_eq x7 (Curry_Prelude.C_Char '%'#) cd cs) cd cs)
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_137 x3 x1 l cd cs) (d_C__case_137 x3 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_137 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_137 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "REPL._case_137" [(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "REPL._case_137" (showCons x4))

d_C__case_136 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_136 x7 x6 x5 x1 x3 x9 cd cs = case x9 of
     Curry_Prelude.C_True -> let
          x8 = x5
           in (d_C__case_135 x8 x6 x1 x5 x3 (Curry_Prelude.d_OP_eq_eq x8 (Curry_Prelude.C_Char '%'#) cd cs) cd cs)
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x3 (d_OP_calcPrompt_dot_subst_dot_39 x1 (Curry_Prelude.OP_Cons x5 x6) cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_136 x7 x6 x5 x1 x3 l cd cs) (d_C__case_136 x7 x6 x5 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_136 x7 x6 x5 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_136 x7 x6 x5 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_136" [(show x7),(show x6),(show x5),(show x1),(show x3),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_136" (showCons x9))

d_C__case_135 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_135 x8 x6 x1 x5 x3 x9 cd cs = case x9 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '%'#) x6
     Curry_Prelude.C_False -> d_C__case_134 x8 x6 x1 x5 x3 (Curry_Prelude.d_OP_eq_eq x8 (Curry_Prelude.C_Char 's'#) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_135 x8 x6 x1 x5 x3 l cd cs) (d_C__case_135 x8 x6 x1 x5 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_135 x8 x6 x1 x5 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_135 x8 x6 x1 x5 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_135" [(show x8),(show x6),(show x1),(show x5),(show x3),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_135" (showCons x9))

d_C__case_134 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_134 x8 x6 x1 x5 x3 x9 cd cs = case x9 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x1 (d_OP_calcPrompt_dot_subst_dot_39 x1 x6 cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x3 (Curry_Prelude.OP_Cons x5 (d_OP_calcPrompt_dot_subst_dot_39 x1 x6 cd cs))
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_134 x8 x6 x1 x5 x3 l cd cs) (d_C__case_134 x8 x6 x1 x5 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_134 x8 x6 x1 x5 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_134 x8 x6 x1 x5 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_134" [(show x8),(show x6),(show x1),(show x5),(show x3),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_134" (showCons x9))

d_C__case_138 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_138 x3 x4 x5 x1 x9 cd cs = case x9 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (d_C_writeErrorMsg (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "unknown command: ") (Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x3 x4) cd cs) cd cs) cd cs) x5 cd cs
     Curry_Prelude.C_False -> let
          x6 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break d_OP_processArgsAndStart_dot_uscore_hash_lambda7 cd cs) x4 cd cs
          x7 = d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs x6 cd cs
          x8 = d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more x6 cd cs
           in (Curry_Prelude.d_OP_gt_gt_eq (d_C_processCommand x1 (Curry_Prelude.d_C_tail (Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x3 x7) cd cs) cd cs) cd cs) (d_OP_processArgsAndStart_dot_uscore_hash_lambda8 x8 x5) cd cs)
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_138 x3 x4 x5 x1 l cd cs) (d_C__case_138 x3 x4 x5 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_138 x3 x4 x5 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_138 x3 x4 x5 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_138" [(show x3),(show x4),(show x5),(show x1),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_138" (showCons x9))

nd_C__case_138 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit -> Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C__case_138 x3 x4 x5 x1 x9 s cd cs = case x9 of
     Curry_Prelude.C_True -> let
          s0 = s
           in (seq s0 (Curry_Prelude.nd_OP_gt_gt (d_C_writeErrorMsg (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "unknown command: ") (Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x3 x4) cd cs) cd cs) cd cs) x5 s0 cd cs))
     Curry_Prelude.C_False -> let
          s4 = s
           in (seq s4 (let
               s2 = leftSupply s4
               s3 = rightSupply s4
                in (seq s2 (seq s3 (let
                    x6 = let
                         s1 = leftSupply s2
                         s0 = rightSupply s2
                          in (seq s1 (seq s0 (Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_break (wrapDX id d_OP_processArgsAndStart_dot_uscore_hash_lambda7) s0 cd cs) x4 s1 cd cs)))
                    x7 = d_OP_processArgsAndStart_dot_uscore_hash_selFP2_hash_cmdargs x6 cd cs
                    x8 = d_OP_processArgsAndStart_dot_uscore_hash_selFP3_hash_more x6 cd cs
                     in (Curry_Prelude.nd_OP_gt_gt_eq (d_C_processCommand x1 (Curry_Prelude.d_C_tail (Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x3 x7) cd cs) cd cs) cd cs) (wrapNX id (nd_OP_processArgsAndStart_dot_uscore_hash_lambda8 x8 x5)) s3 cd cs))))))
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (nd_C__case_138 x3 x4 x5 x1 l s cd cs) (nd_C__case_138 x3 x4 x5 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> nd_C__case_138 x3 x4 x5 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((nd_C__case_138 x3 x4 x5 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_138" [(show x3),(show x4),(show x5),(show x1),(show x9)] info)
     _ -> failCons cd (consFail "REPL._case_138" (showCons x9))

d_C__case_140 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_140 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> d_C_cleanUpRepl x1 cd cs
     Curry_Prelude.C_False -> d_C__case_139 x1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_140 x1 l cd cs) (d_C__case_140 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_140 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_140 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_140" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_140" (showCons x2))

d_C__case_139 :: Curry_Linker.C_ReplState -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_139 x1 x2 cd cs = case x2 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_gt_gt_eq (d_C_getBanner cd cs) (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 1#)) cd cs) (Curry_Prelude.d_OP_gt_gt (Curry_Linker.d_C_writeVerboseInfo x1 (Curry_Prelude.C_Int 1#) (Curry_Prelude.toCurryString "Type \":h\" for help  (contact: kics2@curry-language.org)") cd cs) (d_C_repl x1 cd cs) cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_139 x1 l cd cs) (d_C__case_139 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_139 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_139 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "REPL._case_139" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "REPL._case_139" (showCons x2))